EnableExplicit

#HideText = 0 ; not very optimized!!! - for testing
; Copyright (C) 2007-2010 Jan Vorel
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
; If you have any questions, suggestions or bug reports about this product,
; contact me: info@ctuser.net; Do not contact me about general B.A.S.I.C.
; language or A.P.I. issues

; Wavedata To spectrum Data conversation is based on a free Visual Basic 6
; example by Ulli "Mhlenweg" <umgedv@yahoo.com>, which can be found at
; http://www.planetsourcecode.com/vb/scripts/ShowCode.asp?txtCodeId=65007&lngWId=1

CompilerSelect (#LEDMode >> 8) & $ff
  CompilerCase  $0 ; none
    ;#CustomPeakRender
    #CustomPeakRender = #False
    #RenderMainInfoMySelf = 0
    #LEDMdSpec = #False
    #LEDMdHist = #False
    #LEDMdWave = #False
    #LEDMdWaveDual = #False
    #LEDMdWaveQuad = #False
  CompilerCase $FF ; Custom
    #CustomPeakRender = #True
    #RenderMainInfoMySelf = 3
    #LEDMdSpec = #False
    #LEDMdHist = #False
    #LEDMdWave = #False
    #LEDMdWaveDual = #False
    #LEDMdWaveQuad = #False
  CompilerCase  $1 ; Classic Spectrum
    #CustomPeakRender = #False
    #RenderMainInfoMySelf = 3
    #LEDMdSpec = #False
    #LEDMdHist = #False
    #LEDMdWave = #False
    #LEDMdWaveDual = #False
    #LEDMdWaveQuad = #False
  CompilerCase  $2 ; Classic WaveForms
    #CustomPeakRender = #False
    #RenderMainInfoMySelf = 0
    #LEDMdSpec = #False
    #LEDMdHist = #False
    #LEDMdWave = #True
    #LEDMdWaveDual = #False
    #LEDMdWaveQuad = #False
  CompilerCase  $3 ; Mixed Spectrum / WaveForms
    #CustomPeakRender = #False
    #RenderMainInfoMySelf = 3
    #LEDMdSpec = #False
    #LEDMdHist = #False
    #LEDMdWave = #True
    CompilerIf (#LEDMode) & $ff = 1
      #LEDMdWaveDual = #True : #LEDMdWaveQuad = #False
      CompilerElseIf (#LEDMode) & $ff = 2
      #LEDMdWaveDual = #False: #LEDMdWaveQuad = #True
      CompilerElse
      #LEDMdWaveDual = #False: #LEDMdWaveQuad = #False
      CompilerEndIf

    #LEDMdWaveMirr = #False
    #LEDMdWaveQuadFlip = #False
  CompilerCase $10 ; Specials cat 1
    #CustomPeakRender = #False
    #RenderMainInfoMySelf = 3
    CompilerIf (#LEDMode) & $ff = 1
      #LEDMdHist = #True
      #LEDMdSpec = #False
      CompilerElse
      #LEDMdHist = #False
      #LEDMdSpec = #True
      CompilerEndIf
    #LEDMdWave = #False
    #LEDMdWaveDual = #False
    #LEDMdWaveQuad = #False
  CompilerEndSelect

;#WPPicMode = 1
;CompilerIf #CustomPeakRender
  ;#RenderMainInfoMySelf = 3
  ;CompilerElse
  ;#RenderMainInfoMySelf = 0
  ;CompilerEndIf
  


#FixedUse = 2
CompilerIf #CustomPeakRender
  Macro DimColorASMPrepared()
    CompilerIf #HideText
      CompilerElse
  
        FLD X1
  
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
        XOR rax, rax
        MOV rcx, rax
        MOV eax, X2
        PUSH rax
        MOV rdx, rsp
        ADD rdx, 4
        MOV rax, rdx
        DEC rax
        MOV [rax], cl
        DEC rax
        FILD word [rax]
        FMUL st, st1
        FISTP word [rdx]
        MOV [rax], byte cl
        DEC rax
        INC rdx
        
        FILD word [rax]
        FMUL st, st1
        FISTP word [rdx]
        MOV [rax], byte cl
        DEC rax
        INC rdx
        
        FILD word [rax]
        FMUL st, st1
        FISTP word [rdx]
        MOV eax, [rax + 3]
        BSWAP eax
        ADD rsp, 8
        MOV X2, eax
        FSTP ST0
        CompilerElse
        MOV eax, X2
        XOR ecx, ecx
        PUSH ecx
        MOV edx, esp
        PUSH eax
        MOV eax, edx
        DEC eax
        MOV [eax], cl
        DEC eax
        FILD word [eax]
        FMUL st, st1
        FISTP word [edx]
        MOV [eax], byte cl
        DEC eax
        INC edx
        
        FILD word [eax]
        FMUL st, st1
        FISTP word [edx]
        MOV [eax], byte cl
        DEC eax
        INC edx
        
        FILD word [eax]
        FMUL st, st1
        FISTP word [edx]
        MOV eax, [eax + 3]
        BSWAP eax
        ADD esp, 8
        MOV X2, eax
        FSTP ST0
        CompilerEndIf
      CompilerEndIf
    EndMacro

  ;#BarPos = 4
  #StereoBMP = 0
  #SpectrumColor = -1
  #LEDMdSpec = #False
  #LEDMdHist = #False
  Global RenderInnerHeight.i
  Global RenderInnerTop.i
  Global ParticleCenterX.i
  Global ParticleCenterY.i
  CompilerElse
  CompilerIf #StereoBMP
    CompilerElse
    #MaxSpecOnScreenHeightPX = 440
    CompilerEndIf
  CompilerEndIf
#JPGWPRes = #True

CompilerSelect #BarPos
  CompilerCase 0
    #HAlign = 0
  CompilerCase 1
    #HAlign = 0
  CompilerCase 2
    #HAlign = 0
  CompilerDefault
    #HAlign = 1
  CompilerEndSelect


CompilerIf #OnPicRender
  CompilerIf #HideText
    CompilerElse
      Global ptrAlphaBlend.i
    Global IsAlpha.l
    CompilerEndIf
  CompilerEndIf

CompilerIf #StereoBMP
  CompilerIf #StereoBMPSep And #StereoBMP = 2
    Global Dim xCurSpec.f(5);31)
    Global Dim xSpecMax.l(5)
    Global Dim xCurSpecX.l(5)
    CompilerElse
    Global Dim xCurSpec.f(2);31)
    Global Dim xSpecMax.l(2)
    Global Dim xCurSpecX.l(2)
    CompilerEndIf

  #PalCountX = #PalCount - 1
  #PalCountRMM = #PalCount * 4
  Global Dim xPal1.l(#PalCountX)
  #ExtraBmp1WidthX = #ExtraBmp1Width + 1
  #ExtraBmp1HeightX = #ExtraBmp1Height + 1

  Global ExtraBmp1Left.l
  Global ExtraBmp1Top.l
  Global ExtraBmp1Width.l
  Global ExtraBmp1Height.l

  CompilerIf #StereoBMP = 2
    Global Dim xPal2.l(#PalCountX)

    #ExtraBmp2WidthX = #ExtraBmp2Width + 1
    #ExtraBmp2HeightX = #ExtraBmp2Height + 1

    Global ExtraBmp2Left.l
    Global ExtraBmp2Top.l
    Global ExtraBmp2Width.l
    Global ExtraBmp2Height.l
    CompilerEndIf
  CompilerElse
  ;#WallBmpWidth = 0
  ;#WallBmpHeight = 0
  CompilerIf #CustomPeakRender
    CompilerElse
    Global SpecData.i
    CompilerIf #LEDMdWave
      CompilerIf #LEDMdWaveQuad
        Global SpecData2.i
        CompilerEndIf
      CompilerEndIf
    Global PeaksCX.i
    Global PeaksCXX.i
    #PeakW = 4;10
    CompilerIf #LEDMdSpec 
      CompilerElseIf #LEDMdHist
      Global HistRect.i
      Global HistMult.i
      Structure strHISTRECT Extends RECT
        Value1.l
        Value2.l
        EndStructure
      #lenHISTRECT = 24
      Global *HistRCur.strHISTRECT
      Global HistRMax.i
      CompilerEndIf
    CompilerEndIf
  CompilerIf #StereoBMP
    CompilerElse
    CompilerIf #SpectrumColor = -1
      Global PeaksCols.i
      CompilerEndIf
    CompilerIf #CustomPeakRender
      CompilerElse
      CompilerIf #LEDMdSpec
        #LEDTriggerBoost = 0.125
        CompilerIf #ColorizedBackColor
          #ClearOldInfoBmp = #False
          CompilerElse
          #ClearOldInfoBmp = #True
          CompilerEndIf
        CompilerElse
        #ClearOldInfoBmp = #True
        CompilerEndIf
      CompilerEndIf
    CompilerIf #ClearOldInfoBmp
      CompilerElse
      Global OneTimeClearOldInfoBmp.i
      CompilerEndIf
    CompilerEndIf
;CompilerIf #SpectrumRedrawInfo
;  #PeaksCY = 12 ;10&
;CompilerElse
;  #PeaksCY = 8 ;10&
;CompilerEndIf
  CompilerIf #CustomPeakRender
    CompilerElse
    CompilerIf #LEDMdSpec; Or #LEDMdHist
      #PeakH = 2
      CompilerIf #SpectrumRedrawInfo
        #PeaksCYLEDFixedO = 12
        CompilerElse
        #PeaksCYLEDFixedO = 8
        CompilerEndIf
      CompilerElse
      #PeakH = 3
      #PeaksCYLEDFixedO = #PeaksCY
      CompilerEndIf
    #PeaksCYPM = (#PeaksCY + 1) * 1.25
    #PeaksCYX = #PeaksCY - 1
    CompilerIf #SpectrumColor = -1
      Macro UseInitColorsFadingEx()
        Procedure InitColorsFadingEx(VersionMode.i, IDFrom, IDWidth, Color1, Color2)
          Define.i ICFE_Width = IDWidth
          Define.i ICFE_WidthX = IDWidth - 1
          Define.i ICFE_xCounter

          Define.i ICFE_Red1 =  Color1 >> 16
          Define.i ICFE_Grn1 = (Color1 & $ff00)
          Define.i ICFE_Blu1 = (Color1 & $ff) << 16

          Define.i ICFE_Red2 =  Color2 >> 16
          Define.i ICFE_Grn2 = (Color2 & $ff00)
          Define.i ICFE_Blu2 = (Color2 & $ff) << 16

          CompilerIf #ColorizedBackColor And #LEDMdSpec
            Define.i ICFE_Pointer = PeaksCols + (IDFrom << 3)
            CompilerElse
            Define.i ICFE_Pointer = PeaksCols + (IDFrom << 2)
            CompilerEndIf
      
          If VersionMode = 2
            ;Define.f RGBMixCodeVar1_#ID = $ff / ICFE_WidthX / Sqr(Sqr(ICFE_WidthX))
            Define.f IFCE_MixDiv = $ff / ICFE_WidthX / Sqr(Sqr(ICFE_WidthX))
            EndIf
      
      
          For ICFE_xCounter = 0 To ICFE_WidthX
            ;RGBMixCode1(xLong1, SpecSizeHalf)
            If VersionMode = 2
              Define.i ICFE_MixFactor1 = (ICFE_xCounter * Sqr(Sqr(ICFE_xCounter)) * IFCE_MixDiv)
              Else
              Define.i ICFE_MixFactor1 = (ICFE_xCounter * 255) / ICFE_WidthX
              EndIf
            Define.i ICFE_MixFactor2 = 255 - ICFE_MixFactor1
  
            Define.i ICFE_xCol.i = (((ICFE_Red1 * ICFE_MixFactor2 + ICFE_Red2 * ICFE_MixFactor1) / 255) & $ff)
                     ICFE_xCol   | (((ICFE_Grn1 * ICFE_MixFactor2 + ICFE_Grn2 * ICFE_MixFactor1) / 255) &   $ff00)
                     ICFE_xCol   | (((ICFE_Blu1 * ICFE_MixFactor2 + ICFE_Blu2 * ICFE_MixFactor1) / 255) &     $ff0000)
            PokeL(ICFE_Pointer, ICFE_xCol)
            CompilerIf #ColorizedBackColor And #LEDMdSpec
              PokeL(ICFE_Pointer + 4, (ICFE_xCol & $fcfcfc) >> 2)
              ICFE_Pointer + 8
              CompilerElse
              ICFE_Pointer + 4
              CompilerEndIf
            Next
          EndProcedure
        EndMacro

      Macro InitColorsBy3Colors(Mode, Color1, Color2, Color3)
        Define.i SpecSizeHalf
    
        #ICFE_Color1#MacroExpandedCount = Color1
        #ICFE_Color2#MacroExpandedCount = Color2
        #ICFE_Color3#MacroExpandedCount = Color3
        SpecSizeHalf = (PeaksCX + 1) >> 1
        InitColorsFadingEx(Mode, 0, SpecSizeHalf, #ICFE_Color1#MacroExpandedCount, #ICFE_Color2#MacroExpandedCount)
        InitColorsFadingEx(Mode, SpecSizeHalf, SpecSizeHalf, #ICFE_Color2#MacroExpandedCount, #ICFE_Color3#MacroExpandedCount)
        EndMacro
    
      Macro InitColorsBy2Colors(Mode, Color1, Color2)
        #ICFE_Color1#MacroExpandedCount = Color1
        #ICFE_Color2#MacroExpandedCount = Color2
        InitColorsFadingEx(Mode, 0, PeaksCX, #ICFE_Color1#MacroExpandedCount, #ICFE_Color2#MacroExpandedCount)
        EndMacro


      Declare InitColors(PeaksCX.i)
      CompilerEndIf
    #PeakDW = #PeakW * 13 / 10
    #PeakDH = 5
    Global PeaksCYLEDFixed.i
    Global SizeTY.i

    CompilerIf (#PeaksCYLEDFixedO + 2) * #PeakDH - 3*#PeakH > #MaxSpecOnScreenHeightPX
      #PeaksCYLEDFixed = (#MaxSpecOnScreenHeightPX + 3*#PeakH) / #PeakDH - 2
      #SizeTY = (#PeaksCYLEDFixed + 2) * #PeakDH - 3*#PeakH
;Debug "Fixed: " + Str(#SizeTY)
      CompilerElse
      #SizeTY = (#PeaksCYLEDFixedO + 2) * #PeakDH - 3*#PeakH
      #PeaksCYLEDFixed = #PeaksCYLEDFixedO
;Debug "Kept: " + Str(#SizeTY)
      CompilerEndIf
    Global BottomPos.l
    CompilerEndIf
  Global LeftPos.l
  Global SizeTX.l
  CompilerEndIf




Global RenderLeft.l
Global RenderTop.l
Global RenderWidth.l
Global RenderHeight.l
CompilerIf #OnPicRender
  #PicStretch = 100
  CompilerElse
  Global ClearRectLeft.RECT
  Global ClearRectRight.RECT
  Global ClearRectTop.RECT
  Global ClearRectBottom.RECT
  CompilerEndIf
Global SrcMarginLeft.l
Global SrcMarginTop.l
Global SrcMarginWidth.l
Global SrcMarginHeight.l

#AnimPlugin = 1
#RenderSelf = 1
#SpectrumArraySize = 3
#PSFMode = 0

Global RenderMainInfoMySelf_RPLeft.l

CompilerIf #MaxTick
  Declare RenderSelf(SkipFrame.l, xElapsedTicks.l)
  CompilerElse
  Declare RenderSelf(SkipFrame.l)
  CompilerEndIf
Declare ResizedSelf()
Declare EraseBkGndSelf()
Declare.i LoadResEx_Data(resFileName.s, resType.s)
Declare.l InitSelf()
Declare TerminateSelf()

CompilerIf #StereoBMP
  CompilerIf #WPID = 2010 Or #WPID = 2014 Or #WPID = 20146 Or #WPID = 2011 Or #WPID = $4D464254
    Global ExtraRed.l
    Global ExtraRedC.l
    CompilerEndIf
  CompilerElseIf #LEDMdSpec
  CompilerElseIf #LEDMdHist
  Global *xCurHRect.strHISTRECT
  CompilerEndIf

#FixedUseBkColor = $0 ;231B18
#FixedUseFrColor = $FFFFFF

#SmallerFonts = 1
;Global hDCTemp.i
Global hDCTemp2.i
Global hDCTemp3.i
Global hBmp3.i
Global hBmpOld3.i

Global hBmp1.i
Global hBmpOld2.i

CompilerIf #StereoBMP
  Global hBmp2a.i
  Global hData1a.i
  Global hDatabiHeight1.i
  Global hData2a.i

  CompilerIf #StereoBMP = 2
    Global hBmp2b.i
    ;Global hBmpOld2.i
    Global hData1b.i
    Global hDatabiHeight2.i
    Global hData2b.i
    CompilerEndIf
  CompilerEndIf


Global MaxInit.l
MaxInit = 5
IncludeFile "LSDemo.pb"

CompilerIf #AlphaBackColor = -1
  CompilerElse
  #AlphaBackColorRealRGB = InvertRGBConst(#AlphaBackColor)
  CompilerEndIf


CompilerIf #MaxTick
Procedure RenderSelf(SkipFrame.l, xElapsedTicks.l)
CompilerElse
Procedure RenderSelf(SkipFrame.l)
CompilerEndIf
  Define *hMem

  If SkipFrame
    If Not MaxInit = 100
      MaxInit + 1
      EndIf
    EndIf
  
  CompilerIf #StereoBMP
    Define.l xLong1
    Define.l xLong2
    Define.l xLong3
    Define.l xLong4
    CompilerIf #WPID = 2010 Or #WPID = 2014 Or #WPID = 20146 Or #WPID = 2011 Or #WPID = $4D464254
      Define.l xLong5
      Define.l xBool1
      CompilerEndIf
    CompilerIf #WPID = 20146
      Define.i PreCrit
      CompilerEndIf
  
    If SetWaveData(0)
      CompilerIf #StereoBMPSep
        GetFullSpectrumStereoOpt(0)
        SpectrumCompactStereo(0, 1024, @xCurSpec(0), 3)
        CompilerElse
        GetFullSpectrumMonoOpt(0)
        SpectrumCompactMono(0, 1024, @xCurSpec(0), 3)
        CompilerEndIf
      CompilerIf #WPID = 20146
        xLong1 = GetTickCount_()
        If (xLong1 & $7000) = $0000
          PreCrit = #True
          ElseIf (xLong1 & $7000) = $1000
          Select (xLong1 & $e00)
            Case $000
              xCurSpec(0) = 1
              xCurSpec(1) = 1
              xCurSpec(2) = 1
              PreCrit = #True
            Case $200
              xCurSpec(0) = 1
              xCurSpec(1) = 1
              xCurSpec(2) = 1
              PreCrit = #True
            Case $400
              xCurSpec(0) = 0
              xCurSpec(1) = 0
              xCurSpec(2) = 1
              PreCrit = #True
            Case $600
              xCurSpec(0) = 1
              xCurSpec(1) = 1
              xCurSpec(2) = 1
              PreCrit = #True
            Case $800
              xCurSpec(0) = 1
              xCurSpec(1) = 1
              xCurSpec(2) = 1
            Case $a00
              xCurSpec(0) = 0
              xCurSpec(1) = 0
              xCurSpec(2) = 1
            Case $c00
              xCurSpec(0) = 1
              xCurSpec(1) = 1
              xCurSpec(2) = 1
            Case $e00
              xCurSpec(0) = 1
              xCurSpec(1) = 1
              xCurSpec(2) = 1
            EndSelect
          EndIf
        CompilerEndIf
      EndIf

CompilerIf #StereoBMPSep
    For xLong1 = 0 To 5
CompilerElse
    For xLong1 = 0 To 2
CompilerEndIf
      xLong2 = xCurSpec(xLong1) * 100 * 100 * #BasePalBoost
      If xLong2 < 1000
        xLong2 = 1000
        ElseIf xLong2 > 10000
        xLong2 = 10000
        EndIf
      If xLong2 > xSpecMax(xLong1)
        xSpecMax(xLong1) = xLong2
        Else
        xSpecMax(xLong1) = xSpecMax(xLong1) - 25
        EndIf
      xCurSpecX(xLong1) = xCurSpec(xLong1) * MaxInit * 100
      xCurSpecX(xLong1) = xCurSpec(xLong1) * MaxInit * 100
      Next
    CompilerIf #StereoBMPSep
      If xSpecMax(3) > xSpecMax(0): xSpecMax(0) = xSpecMax(3): EndIf
      If xSpecMax(4) > xSpecMax(1): xSpecMax(1) = xSpecMax(4): EndIf
      If xSpecMax(5) > xSpecMax(2): xSpecMax(2) = xSpecMax(5): EndIf
    
      If xCurSpecX(0) < xCurSpecX(3): xCurSpecX(0) = xCurSpecX(3): EndIf
      If xCurSpecX(1) < xCurSpecX(4): xCurSpecX(1) = xCurSpecX(4): EndIf
      If xCurSpecX(2) < xCurSpecX(5): xCurSpecX(2) = xCurSpecX(5): EndIf
      CompilerEndIf
    CompilerIf #WPID = 2010 Or #WPID = 2014 Or #WPID = 20146 Or #WPID = 2011 Or #WPID = $4D464254
      xLong5 = xCurSpecX(0) * $ff / xSpecMax(0) + xCurSpecX(1) * $ff / xSpecMax(1) + xCurSpecX(2) * $ff / xSpecMax(2)
      ;If xCurSpecX(0) / xSpecMax(0) + xCurSpecX(1) / xSpecMax(1) + xCurSpecX(2) / xSpecMax(2) 
      If xLong5 > 20
        ExtraRed - 95
        If ExtraRed < 0: ExtraRed = 0: EndIf
        Else
        ExtraRed + 95
        If ExtraRed > $7ff: ExtraRed = $7ff: EndIf
        EndIf
      If ExtraRed > $400 ;Or ExtraRedC
        ExtraRedC = (ExtraRedC + 95) & $7FF
        xBool1 = 1
        Else
        ExtraRedC = 0
        EndIf
      CompilerEndIf

    For xLong1 = 0 To #PalCountX
      xLong3 = PeekL(@xPal1(xLong1))
      xLong2 = (xLong3 & $ff) * (#BasePalMul + #BasePalOver * xCurSpecX(0) / xSpecMax(0))
      If xLong2 > 255: xLong2 = 255: EndIf
      xLong4 = xLong2
      xLong2 = (xLong3 & $ff00) / $100 * (#BasePalMul + #BasePalOver * xCurSpecX(1) / xSpecMax(1))
      CompilerIf #WPID = $4D464254
        If xBool1
          xLong5 = ((xLong3 & $ff00) / $300 * Sin(ExtraRedC / $800 * #PI))
          xLong5 + ((xLong3 & $ff00) / $100 * (ExtraRed - $400)) / $500 / 16
          xLong2 + xLong5
          EndIf
        CompilerEndIf
      If xLong2 > 255: xLong2 = 255: EndIf
      xLong4 + xLong2 * $100

      xLong2 = (xLong3 & $ff0000) / $10000 * (#BasePalMul + #BasePalOver * xCurSpecX(2) / xSpecMax(2))
      CompilerIf #WPID = 2010 Or #WPID = 2014 Or #WPID = 20146 Or #WPID = 2011 Or #WPID = $4D464254
        If xBool1
          CompilerIf #WPID = $4D464254
            xLong5 = ((xLong3 & $ff0000) / $30000 * Sin(ExtraRedC / $800 * #PI))
            xLong5 + ((xLong3 & $ff0000) / $10000 * (ExtraRed - $400)) / $180 / 16
            CompilerElseIf #WPID = 2014 Or #WPID = 20146
            xLong5 = ((xLong3 & $ff0000) / $10000 * Sin(ExtraRedC / $800 * #PI)) / 1.5
            xLong5 + ((xLong3 & $ff0000) / $10000 * (ExtraRed - $400)) / $800 / 1.5
            CompilerElse
            xLong5 = ((xLong3 & $ff0000) / $10000 * Sin(ExtraRedC / $800 * #PI))
            CompilerIf #WPID = 2011
              xLong5 + ((xLong3 & $ff0000) / $10000 * (ExtraRed - $400)) / $500
              CompilerElse        
              xLong5 + ((xLong3 & $ff0000) / $10000 * (ExtraRed - $400)) / $180
              CompilerEndIf
            CompilerEndIf
          xLong2 + xLong5
          EndIf
        ;Debug Str(xLong5) + " / " + Str(ExtraRed)
        CompilerEndIf
      If xLong2 > 255: xLong2 = 255: EndIf
      xLong4 + xLong2 * $10000
      
CompilerIf #WPID = 20146
  If PreCrit
    xLong4 = (xLong4 & $c0c0c0)
    EndIf
  CompilerEndIf


      PokeL(hData1a + 40 + xLong1 * 4, xLong4)
  
      CompilerIf #StereoBMP = 2
        xLong3 = PeekL(@xPal2(xLong1))
        ;xLong2 = (xLong3 & $ff0000) / $10000 * xCurSpecX(2) / 10000
        xLong2 = (xLong3 & $ff0000) / $10000 * (#BasePalMul + #BasePalOver * xCurSpecX(2) / xSpecMax(2))
        CompilerIf #WPID = $4D464254
          If xBool1
            xLong5 = ((xLong3 & $ff0000) / $30000 * Sin(ExtraRedC / $800 * #PI))
            xLong5 + ((xLong3 & $ff0000) / $10000 * (ExtraRed - $400)) / $180 / 16
            xLong2 + xLong5
            EndIf
          CompilerEndIf
        If xLong2 > 255: xLong2 = 255: EndIf
        xLong4 = xLong2 * $10000
    
        ;xLong2 = (xLong3 & $ff00) / $100 * xCurSpecX(1) / 10000
        xLong2 = (xLong3 & $ff00) / $100 * (#BasePalMul + #BasePalOver * xCurSpecX(1) / xSpecMax(1))
        CompilerIf #WPID = $4D464254
          If xBool1
            xLong5 = ((xLong3 & $ff00) / $300 * Sin(ExtraRedC / $800 * #PI))
            xLong5 + ((xLong3 & $ff00) / $100 * (ExtraRed - $400)) / $500 / 16
            xLong2 + xLong5
            EndIf
          CompilerEndIf
        If xLong2 > 255: xLong2 = 255: EndIf
        xLong4 + xLong2 * $100
    
        ;xLong2 = (xLong3 & $ff) * xCurSpecX(0) / 10000
        xLong2 = (xLong3 & $ff) * (#BasePalMul + #BasePalOver * xCurSpecX(0) / xSpecMax(0))
        If xLong2 > 255: xLong2 = 255: EndIf
        xLong4 + xLong2
        
        PokeL(hData1b + 40 + xLong1 * 4, xLong4)
        CompilerEndIf
      Next
  

    If SetDIBits_(hDCTemp, hBmp2a, 0, hDatabiHeight1, hData2a, hData1a, 0)
      If SelectObject_(hDCTemp, hBmp2a)
        StretchBlt_(hDCTemp2, ExtraBmp1Left, ExtraBmp1Top, ExtraBmp1Width, ExtraBmp1Height, hDCTemp, 0, 0, #ExtraBmp1Width, #ExtraBmp1Height, #SRCCOPY)
        BitBlt_(xMainDC, RenderLeft + ExtraBmp1Left, RenderTop + ExtraBmp1Top, ExtraBmp1Width, ExtraBmp1Height, hDCTemp2, ExtraBmp1Left, ExtraBmp1Top, #SRCCOPY)
        EndIf
      EndIf
    CompilerIf #StereoBMP = 2
      If SetDIBits_(hDCTemp, hBmp2b, 0, hDatabiHeight2, hData2b, hData1b, 0)
        If SelectObject_(hDCTemp, hBmp2b)
          StretchBlt_(hDCTemp2, ExtraBmp2Left, ExtraBmp2Top, ExtraBmp2Width, ExtraBmp2Height, hDCTemp, 0, 0, #ExtraBmp2Width, #ExtraBmp2Height, #SRCCOPY)
          BitBlt_(xMainDC, RenderLeft + ExtraBmp2Left, RenderTop + ExtraBmp2Top, ExtraBmp2Width, ExtraBmp2Height, hDCTemp2, ExtraBmp2Left, ExtraBmp2Top, #SRCCOPY)
          EndIf
        EndIf
      CompilerEndIf


    CompilerIf #HideText
      CompilerElse
      CompilerEndIf

    CompilerElse
    CompilerIf #CustomPeakRender
      CompilerElse
      Define.l xLong1
      Define.l xLong2
  
      CompilerIf #SpectrumColor = -1
        Define.l xLong3
        CompilerEndIf
      CompilerIf #LEDMdSpec Or #LEDMdWaveQuad
        Define.l xLong6
        CompilerIf #LEDMdWaveQuad
          Define.l xLong7
          CompilerEndIf
        CompilerElse
        Define.l xLong7
        CompilerEndIf
      Define.l xLong4
      ;Define.l xLong5
      Define.i hBrushPX
      CompilerEndIf

    Define.RECT xType1
    
CompilerIf #CustomPeakRender
    If hBmpOld3
CompilerElseIf #LEDMdWaveQuad
    If SpecData And SpecData And hBmpOld3
CompilerElse
    If SpecData And hBmpOld3
CompilerEndIf
      CompilerIf #CustomPeakRender
        CompilerElse
        CompilerIf #LEDMdSpec
          If SetWaveData(0)
            GetFullSpectrumStereoOpt(0)
            SpectrumCompactStereo(0, 1024, SpecData, PeaksCX)
            EndIf
          CompilerElseIf #LEDMdHist
          If SetWaveData(0)
            GetFullSpectrumStereo(0)
            SpectrumCompactStereo(0, 1024, SpecData, 1)
            EndIf
          CompilerElse
CompilerIf #LEDMdWaveDual Or #LEDMdWaveQuad
          If RecGetWavedataAsFullSpectrumStereo(0, 0)
            SpectrumCompactStereo(0, 1024, SpecData, PeaksCX)
            CompilerIf #LEDMdWaveQuad
              SetWaveData(0)
CompilerIf #False
              GetFullSpectrumStereoOpt(0)
              ;SpectrumArrayStretchStereo(0, 1024, 0, 4, SpecData2, PeaksCX, 0, PeaksCX)
              ;RtlZeroMemory_(SpecData2, PeaksCX * 4 * 2)
              ;#44_100_KHz = 1024
              ;#22_050_KHz = 512
              ;#11_025_KHz = 256
              ;Debug "NumVLS: " + PeaksCX
              
              SpectrumArrayStretchStereo(0, 1024, 0, 256, SpecData2, PeaksCX, 0, PeaksCX, 33)
              ;SpectrumArrayStretchStereo(0, 1024, 0, 1024, SpecData2, PeaksCX, 0, 8, 100)
              ;SpectrumArrayStretchStereo(SpecData2, PeaksCX, 0, 8, SpecData2, PeaksCX, 8, PeaksCX - 8, 100)
              ;SpectrumCopyDataStereo(0, 1024, 0, 128, 0, 128, 0)
              ;SpectrumStretchStereo(0, 128
              ;SpectrumStretchStereo(0, 1024, SpecData2, PeaksCX)
              ;SpectrumStretchStereo(0, 1024, SpecData2, PeaksCX)
              ;If PeaksCX > 1024
                ;SpectrumCompactStereo(0, 1024, SpecData2, PeaksCX)
                ;ElseIf PeaksCX > 128
                ;SpectrumCopyDataStereoSM(0, 1024, SpecData2, PeaksCX, 0, PeaksCX, 0)
                ;Else
                ;SpectrumCopyDataStereoSM(0, 1024, 0, 160, 0, 160, 0)
                ;SpectrumCompactStereo(0, 160, SpecData2, PeaksCX)
                ;EndIf
CompilerElse
              GetFullSpectrumStereoOpt(0)
              SpectrumCompactStereo(0, 1024, SpecData2, PeaksCX)
CompilerEndIf
              CompilerEndIf
            EndIf
CompilerElseIf #LEDMdWave
          If RecGetWavedataAsFullSpectrumMono(0, 0)
            SpectrumCompactMono(0, 1024, SpecData, PeaksCX)
            EndIf
CompilerElse
          If SetWaveData(0)
            GetFullSpectrumMonoOpt(0)
            SpectrumCompactMono(0, 1024, SpecData, PeaksCX)
            EndIf
CompilerEndIf
          CompilerEndIf
        CompilerEndIf



CompilerIf #SpectrumColor = -1
CompilerElse
      #SpectrumColorFixed = InvertRGBConst(#SpectrumColor)
      hBrushPX = CreateSolidBrush_(#SpectrumColorFixed)
      If hBrushPX
CompilerEndIf
        CompilerIf #SpectrumRedrawInfo
          CompilerElse
          xType1\Left = LeftPos
          CompilerEndIf
CompilerIf #ClearOldInfoBmp
CompilerElse
;OneTimeClearOldInfoBmp = #False
          If OneTimeClearOldInfoBmp
            OneTimeClearOldInfoBmp = #False
CompilerEndIf
            If hBmp1
      ;        SelectObject_(hDCTemp2, hBmp1)
              CompilerIf #CustomPeakRender
                BitBlt_(hDCTemp3, 0, 0, RenderWidth, RenderInnerHeight, hDCTemp2, 0, RenderInnerTop, #SRCCOPY)
                CompilerElse
                CompilerIf #SpectrumRedrawInfo
                  BitBlt_(hDCTemp3, 0, 0, RenderWidth, #InfoIntHeight, hDCTemp2, 0, BottomPos - #InfoIntHeight, #SRCCOPY)
                  CompilerElse
                  BitBlt_(hDCTemp3, LeftPos, 0, SizeTX, #InfoIntHeight, hDCTemp2, LeftPos, BottomPos - #InfoIntHeight, #SRCCOPY)
                  CompilerEndIf
                CompilerEndIf
              Else
              ;xType1\left = 0
              CompilerIf #SpectrumRedrawInfo
                xType1\Right = RenderWidth
                CompilerElse
                xType1\Right = LeftPos + SizeTX
                CompilerEndIf
              CompilerIf #CustomPeakRender
                xType1\Bottom = RenderInnerHeight
                CompilerElse
                xType1\Bottom = #InfoIntHeight
                CompilerEndIf
              FillRect_(hDCTemp3, @xType1, hBrush)
              EndIf
CompilerIf #ClearOldInfoBmp
CompilerElse
            Else
            If hBmp1
;Debug "LowBitBLt Effective"
              CompilerIf #CustomPeakRender
                BitBlt_(hDCTemp3, 0, InfoTop, RenderWidth, #InfoIntHeight, hDCTemp2, 0, RenderInnerTop + InfoTop, #SRCCOPY)
                CompilerElse
                CompilerIf #SpectrumRedrawInfo
                  BitBlt_(hDCTemp3, 0, 0, RenderWidth, #InfoIntHeight, hDCTemp2, 0, BottomPos - #InfoIntHeight, #SRCCOPY)
                  CompilerElse
                  BitBlt_(hDCTemp3, LeftPos, 0, SizeTX, #InfoIntHeight, hDCTemp2, LeftPos, BottomPos - #InfoIntHeight, #SRCCOPY)
                  CompilerEndIf
                CompilerEndIf
              Else
              ;xType1\left = 0
              CompilerIf #SpectrumRedrawInfo
                xType1\Right = RenderWidth
                CompilerElse
                xType1\Right = LeftPos + SizeTX
                CompilerEndIf
              xType1\top = InfoTop
              xType1\Bottom = xType1\top + #InfoIntHeight
              FillRect_(hDCTemp3, @xType1, hBrush)
              EndIf
            EndIf
CompilerEndIf
        CompilerIf #SpectrumRedrawInfo
          xType1\Left = LeftPos
          CompilerEndIf

        CompilerIf #CustomPeakRender
          CompilerIf #MaxTick
            RenderSelfPart(SkipFrame.l, xElapsedTicks.l)
            CompilerElse
            RenderSelfPart(SkipFrame.l)
            CompilerEndIf
          
          
          CompilerElse
          CompilerIf #SpectrumColor = -1
            xLong3 = PeaksCols
            CompilerEndIf
          CompilerIf #LEDMdSpec
            xLong4 = SpecData
            xLong6 = SpecData + PeaksCX << 2
            For xLong1 = 0 To PeaksCXX
              xType1\Right = xType1\Left + #PeakW
CompilerIf Not #ColorizedBackColor
              If PeekF(xLong4)*4 > #LEDTriggerBoost
CompilerIf #SpectrumColor = -1
                hBrushPX = CreateSolidBrush_(PeekL(xLong3))
                If hBrushPX
CompilerEndIf
                  xType1\Top = #PeakDH ; + #BorderForImage
                  xType1\Bottom = xType1\Top + #PeakH
                  FillRect_(hDCTemp3, @xType1, hBrushPX)
                  If PeekF(xLong6) * 4 > #LEDTriggerBoost
                    xType1\Bottom = #InfoIntHeight - #PeakDH
                    xType1\Top = xType1\Bottom - #PeakH
                    FillRect_(hDCTemp3, @xType1, hBrushPX)
                    EndIf
CompilerIf #SpectrumColor = -1
                  DeleteObject_(hBrushPX)
                  EndIf
                ElseIf PeekF(xLong6)*4 > #LEDTriggerBoost
                hBrushPX = CreateSolidBrush_(PeekL(xLong3))
                If hBrushPX
                  xType1\Bottom = #InfoIntHeight - #PeakDH
                  xType1\Top = xType1\Bottom - #PeakH
                  FillRect_(hDCTemp3, @xType1, hBrushPX)
                  DeleteObject_(hBrushPX)
                  EndIf
CompilerEndIf
                EndIf
CompilerElse
              If PeekF(xLong4)*4 > #LEDTriggerBoost
                hBrushPX = CreateSolidBrush_(PeekL(xLong3))
                If hBrushPX
                  xType1\Top = #PeakDH; #BorderForImage
                  xType1\Bottom = xType1\Top + #PeakH
                  FillRect_(hDCTemp3, @xType1, hBrushPX)
                  If Not PeekF(xLong6) * 4 > #LEDTriggerBoost
                    DeleteObject_(hBrushPX)
                    hBrushPX = CreateSolidBrush_(PeekL(xLong3 + 4))
                    EndIf
                  EndIf
                Else
                hBrushPX = CreateSolidBrush_(PeekL(xLong3 + 4))
                If hBrushPX
                  xType1\Top = #PeakDH ; + #BorderForImage
                  xType1\Bottom = xType1\Top + #PeakH
                  FillRect_(hDCTemp3, @xType1, hBrushPX)
                  If PeekF(xLong6)*4 > #LEDTriggerBoost
                    DeleteObject_(hBrushPX)
                    hBrushPX = CreateSolidBrush_(PeekL(xLong3))
                    EndIf
                  EndIf
                EndIf
              If hBrushPX
                xType1\Bottom = #InfoIntHeight - #PeakDH
                xType1\Top = xType1\Bottom - #PeakH
                FillRect_(hDCTemp3, @xType1, hBrushPX)
                DeleteObject_(hBrushPX)
                EndIf
CompilerEndIf

              xType1\Left = xType1\Left + #PeakDW
              CompilerIf #SpectrumColor = -1
                If #ColorizedBackColor
                  xLong3 + 8
                  Else
                  xLong3 + 4
                  EndIf
                CompilerEndIf
              xLong6 + 4
              xLong4 + 4
              Next
            CompilerElseIf #LEDMdHist
;HistRect
            *HistRCur = *HistRCur + #lenHISTRECT
            If *HistRCur = HistRMax
              *HistRCur = HistRect
              EndIf
            *HistRCur\left = LeftPos + PeaksCXX * #PeakDW
            *HistRCur\right = *HistRCur\left + #PeakW
            *xCurHRect = *HistRCur
#SizeTYH = ((#InfoIntHeight - 1 - 2*#PeakH) >> 1)
            ;If #LEDMdBoost Or (#LEDMdBoost > 0 And #LEDMdBoost < 1)
            ;  xLong1 = PeekF(SpecData) * #LEDMdBoost * #SizeTYH - 1 ; + #PeaksCYPM
            ;  xLong2 = PeekF(SpecData+4) * #LEDMdBoost * #SizeTYH - 1 ; + #PeaksCYPM
            ;  Else
              xLong1 = PeekF(SpecData) * #SizeTYH ; + #PeaksCYPM
              xLong2 = PeekF(SpecData+4) * #SizeTYH ; + #PeaksCYPM
            ;  EndIf
            If xLong1 > #SizeTYH: xLong1 = #SizeTYH: EndIf
            If xLong2 > #SizeTYH: xLong2 = #SizeTYH: EndIf
            ;*HistRCur\Top = #SizeTYH + #PeakDH + #PeakDH - xLong1
            ;*HistRCur\Bottom = #SizeTYH + #PeakDH + #PeakDH + xLong2 + 1
            *HistRCur\Value1 = xLong1
            *HistRCur\Value2 = xLong2

            For xLong1 = 0 To PeaksCXX
              *xCurHRect = *xCurHRect + #lenHISTRECT
              If *xCurHRect = HistRMax
                *xCurHRect = HistRect
                EndIf
            *xCurHRect\Top = #SizeTYH + #PeakH - *xCurHRect\Value1 * PeekF(HistMult + xLong1 * 4)
            *xCurHRect\Bottom = #SizeTYH + #PeakH + *xCurHRect\Value2 * PeekF(HistMult + xLong1 * 4) + 1

CompilerIf #SpectrumColor = -1
              hBrushPX = CreateSolidBrush_(PeekL(xLong3))
              If hBrushPX
CompilerEndIf
                FillRect_(hDCTemp3, *xCurHRect, hBrushPX)
CompilerIf #SpectrumColor = -1
                DeleteObject_(hBrushPX)
                xLong3 + 4
                EndIf
CompilerEndIf
              xType1\Left = xType1\Left + #PeakDW
              xLong4 + 4
              *xCurHRect\left - #PeakDW
              *xCurHRect\right - #PeakDW
              Next

            CompilerElseIf #LEDMdWave Or #LEDMdWaveDual Or #LEDMdWaveQuad
            xLong4 = SpecData
            CompilerIf #LEDMdWaveQuad
              xLong6 = SpecData2
              CompilerEndIf


CompilerIf #LEDMdWaveQuad
  CompilerIf #LEDMdWaveQuadFlip
    #SizeTYHRL = (#InfoIntHeight >> 1)
    #PeaksCYLEDFixedQuad = ((#SizeTYHRL >> 1) + #PeakH) / #PeakDH - 2
    #SizeTYHMP = #SizeTYHRL >> 2
    #SizeTYHP1 = #SizeTYHRL - #SizeTYHMP
    #SizeTYHP2 = #SizeTYHRL + #SizeTYHMP
    ;#SizeTYHP3 = #SizeTYHRL - #SizeTYHMP << 1
    #SizeTYHP3 = #PeaksCYLEDFixedQuad * #PeakDH
    #SizeTYHP4 = #InfoIntHeight - #PeakH
    CompilerElse
    ;#SPResInnerHgt = 64
    #SPResInnerHgtH = 32 ;#SPResInnerHgt >> 1
    ;#SizeTYHRL = ((#InfoIntHeight - #SPResInnerHgt) >> 1)
    #SizeTYHRL = (#InfoIntHeight >> 1)
    #PeaksCYLEDFixedQuad = ((#SizeTYHRL >> 1) + #PeakH) / #PeakDH - 2
    #SizeTYHMP = (#SizeTYHRL - 96) >> 2
    #SizeTYHP3 = #SizeTYHRL - #SPResInnerHgtH
    #SizeTYHP4 = #SizeTYHRL + #SPResInnerHgtH; + #SizeTYHMP << 1 + 2
    #SizeTYHP1 = #PeaksCYLEDFixedQuad << 1 - #PeakDH ;#SizeTYHP3 - #SizeTYHMP * 4
    #SizeTYHP2 = #InfoIntHeight - #SizeTYHP1 - #PeakH
    CompilerEndIf
  CompilerElse
  #SizeTYHRL = ((#InfoIntHeight - 1 - 2*#PeakH) >> 1)
  CompilerIf #LEDMdWaveDual
    #SizeTYHMP = #SizeTYHRL >> 1
    #SizeTYHP1 = #SizeTYHRL - #SizeTYHMP
    #SizeTYHP2 = #SizeTYHRL + #SizeTYHMP
    CompilerElse
    #SizeTYHMP = #SizeTYHRL
    #SizeTYHP1 = #SizeTYHRL
    CompilerEndIf
  CompilerEndIf
            For xLong1 = 0 To PeaksCXX
CompilerIf #SpectrumColor = -1
              hBrushPX = CreateSolidBrush_(PeekL(xLong3))
              If hBrushPX
CompilerEndIf
                xLong2 = PeekF(xLong4) * #SizeTYHMP ; + #PeaksCYPM
Macro DWaveForm(MxPos)
                xType1\Right = xType1\Left + #PeakW
                If xLong2 < 0
                  xType1\Top = MxPos + #PeakH + xLong2
                  CompilerIf #LEDMdWaveFill
                    xType1\Bottom = MxPos + #PeakH
                    CompilerElse
                    xType1\Bottom = xType1\Top + #PeakH
                    CompilerEndIf
                  Else
                  xType1\Bottom = MxPos + #PeakH + xLong2
                  CompilerIf #LEDMdWaveFill
                    xType1\Top = MxPos + #PeakH
                    CompilerElse
                    xType1\Top = xType1\Bottom - #PeakH
                    CompilerEndIf
                  EndIf
                FillRect_(hDCTemp3, @xType1, hBrushPX)
EndMacro
Macro QSpecRnd(MxPos)
                xType1\Top = MxPos + (#PeakDH - #PeakH); - 1
                xType1\Bottom = xType1\Top + 1
                FillRect_(hDCTemp3, @xType1, hBrushPX)

                xType1\Bottom = MxPos; - #PeakH
                xType1\Top = xType1\Bottom - #PeakH
                If xLong2 > #PeaksCYLEDFixedQuad: xLong2 = #PeaksCYLEDFixedQuad: EndIf
                For xLong7 = 0 To xLong2
                  FillRect_(hDCTemp3, @xType1, hBrushPX)
                  xType1\Top = xType1\Top - #PeakDH
                  xType1\Bottom = xType1\Bottom - #PeakDH
                  Next
EndMacro
Macro QSpecRnX(MxPos)
                xType1\Bottom = MxPos - (#PeakDH - #PeakH)
                xType1\Top = xType1\Bottom - 1
                FillRect_(hDCTemp3, @xType1, hBrushPX)

                xType1\Top = MxPos
                xType1\Bottom = xType1\Top + #PeakH
                If xLong2 > #PeaksCYLEDFixedQuad: xLong2 = #PeaksCYLEDFixedQuad: EndIf
                For xLong7 = 0 To xLong2
                  FillRect_(hDCTemp3, @xType1, hBrushPX)
                  xType1\Top = xType1\Top + #PeakDH
                  xType1\Bottom = xType1\Bottom + #PeakDH
                  Next
EndMacro
DWaveForm(#SizeTYHP1)

CompilerIf #LEDMdWaveDual Or #LEDMdWaveQuad
If #LEDMdWaveMirr
  xLong2 = -PeekF(xLong4 + PeaksCX << 2) * #SizeTYHMP ; + #PeaksCYPM
  Else
  xLong2 = PeekF(xLong4 + PeaksCX << 2) * #SizeTYHMP ; + #PeaksCYPM
  EndIf
DWaveForm(#SizeTYHP2)
CompilerIf #LEDMdWaveQuad
                CompilerIf #LEDMdBoost Or (#LEDMdBoost > 0 And #LEDMdBoost < 1)
                  xLong2 = PeekF(xLong6) * #LEDMdBoost * #SizeTYHMP - 1 ; + #PeaksCYPM
                  CompilerElse
                  xLong2 = PeekF(xLong6) * #SizeTYHMP - 1 ; + #PeaksCYPM
                  CompilerEndIf
  QSpecRnd(#SizeTYHP3)
                CompilerIf #LEDMdBoost Or (#LEDMdBoost > 0 And #LEDMdBoost < 1)
                  xLong2 = PeekF(xLong6 + PeaksCX << 2) * #LEDMdBoost * #SizeTYHMP - 1 ; + #PeaksCYPM
                  CompilerElse
                  xLong2 = PeekF(xLong6 + PeaksCX << 2) * #SizeTYHMP - 1 ; + #PeaksCYPM
                  CompilerEndIf
  CompilerIf #LEDMdWaveQuadFlip
    QSpecRnd(#SizeTYHP4)
    CompilerElse
    QSpecRnX(#SizeTYHP4)
    CompilerEndIf
  CompilerEndIf
CompilerEndIf




CompilerIf #SpectrumColor = -1
                DeleteObject_(hBrushPX)
                xLong3 + 4
                EndIf
CompilerEndIf
              xType1\Left = xType1\Left + #PeakDW
              xLong4 + 4
              CompilerIf #LEDMdWaveQuad
                xLong6 + 4
                CompilerEndIf
              Next
            CompilerElse
            xLong4 = SpecData
            For xLong1 = 0 To PeaksCXX
CompilerIf #SpectrumColor = -1
              hBrushPX = CreateSolidBrush_(PeekL(xLong3))
              If hBrushPX
CompilerEndIf
                xType1\Right = xType1\Left + #PeakW
                xType1\Bottom = #InfoIntHeight - #PeakH
                xType1\Top = xType1\Bottom - #PeakH
                
                ;CompilerIf #LEDMdSpec
                ;  xLong2 = PeekF(xLong4) * #PeaksCYPM - 1 ; + #PeaksCYPM
                ;  CompilerElse
                  CompilerIf #LEDMdBoost Or (#LEDMdBoost > 0 And #LEDMdBoost < 1)
                    ;SpecData + xLong1 * 4
                    xLong2 = PeekF(xLong4) * #LEDMdBoost * #PeaksCYPM - 1 ; + #PeaksCYPM
                    CompilerElse
                    xLong2 = PeekF(xLong4) * #PeaksCYPM - 1 ; + #PeaksCYPM
                    CompilerEndIf
                ;  CompilerEndIf
                If xLong2 > #PeaksCYLEDFixed: xLong2 = #PeaksCYLEDFixed: EndIf
                For xLong7 = 0 To xLong2
                  FillRect_(hDCTemp3, @xType1, hBrushPX)
                  xType1\Top = xType1\Top - #PeakDH
                  xType1\Bottom = xType1\Bottom - #PeakDH
                  Next
CompilerIf #SpectrumColor = -1
                DeleteObject_(hBrushPX)
                xLong3 + 4
                EndIf
CompilerEndIf
              xType1\Left = xType1\Left + #PeakDW
              xLong4 + 4
              Next
            CompilerEndIf
          CompilerEndIf

        CompilerIf #HideText
          CompilerElse
          SetTextColor_(hDCTemp3, $ffffff)
          SetBkMode_(hDCTemp3, 1)
          CalcAndDrawInfoPos()
;Debug "RedrawPosEx"
          CompilerIf #CustomPeakRender
            xTxtLastLeft = RenderMainInfoMySelf_RPLeft
            xTxtLastTop = InfoTop
            If *hBitmapTxt
              DrawBmp(*hBitmapTxt, RenderMainInfoMySelf_RPLeft, InfoTop)
              Else
              DrawBmp(*hBitmapGen, RenderMainInfoMySelf_RPLeft, InfoTop)
              EndIf
            CompilerElseIf #LEDMdSpec Or ((#LEDMdWaveDual Or #LEDMdWaveQuad) And Not #LEDMdHist) ;Or #LEDMdHist
;Debug "RedrawPosEx: " + Str(RenderMainInfoMySelf_RPLeft)
            ;xTxtLastLeft = RenderMainInfoMySelf_RPLeft
            ;xTxtLastTop = (#InfoIntHeight >> 1) - 24
            If *hBitmapTxt
              DrawBmp(*hBitmapTxt, RenderMainInfoMySelf_RPLeft, (#InfoIntHeight >> 1) - 24)
              Else
              DrawBmp(*hBitmapGen, RenderMainInfoMySelf_RPLeft, (#InfoIntHeight >> 1) - 24)
              EndIf
            CompilerElse
            xTxtLastLeft = RenderMainInfoMySelf_RPLeft
            xTxtLastTop = 5
            If *hBitmapTxt
              DrawBmp(*hBitmapTxt, RenderMainInfoMySelf_RPLeft, 5) ;#BorderForImage)
              Else
              DrawBmp(*hBitmapGen, RenderMainInfoMySelf_RPLeft, 5) ;#BorderForImage);
              EndIf
            CompilerEndIf
          CompilerEndIf
        CompilerIf #CustomPeakRender
          BitBlt_(xMainDC, 0, RenderInnerTop, RenderWidth, RenderInnerHeight, hDCTemp3, 0, 0, #SRCCOPY)
          CompilerElseIf #SpectrumRedrawInfo
          BitBlt_(xMainDC, 0, BottomPos - #InfoIntHeight, RenderWidth, #InfoIntHeight, hDCTemp3, 0, 0, #SRCCOPY)
          CompilerElse
          BitBlt_(xMainDC, LeftPos, BottomPos - #InfoIntHeight, SizeTX, #InfoIntHeight, hDCTemp3, LeftPos, 0, #SRCCOPY)
          CompilerEndIf


        CompilerIf #SpectrumRedrawInfo
          ;CalcAndDrawInfoPos()
          CompilerEndIf

CompilerIf #SpectrumColor = -1
CompilerElse
        DeleteObject_(hBrushPX)
        EndIf
CompilerEndIf
      EndIf
    CompilerEndIf
CompilerIf #MaxTick
  EndProcedure
CompilerElse
  EndProcedure
CompilerEndIf

Procedure EraseBkGndSelf()
  If hBmp1 ;ExtraBmp2Left
CompilerIf #OnPicRender
CompilerElse
      FillRect_(xMainDC, @ClearRectTop, hBrush)
      FillRect_(xMainDC, @ClearRectBottom, hBrush)
      FillRect_(xMainDC, @ClearRectLeft, hBrush)
      FillRect_(xMainDC, @ClearRectRight, hBrush)
CompilerEndIf
      BitBlt_(xMainDC, RenderLeft, RenderTop, RenderWidth, RenderHeight, hDCTemp2, 0, 0, #SRCCOPY)
      EndIf
  EndProcedure

CompilerIf #JPGWPRes
  Procedure.i OLEInterface_CallFunction1(*ptrInterface, MemberOffset.i, *Param1)
    Define *Addr
    If *ptrInterface
      *Addr = PeekI(*ptrInterface)
      *Addr = PeekI(*Addr + MemberOffset)
      CallFunctionFast(*Addr, *ptrInterface, *Param1)
      EndIf
    EndProcedure
  
  Procedure OLEInterface_Release(*ptrInterface)
    Define *Addr
    If *ptrInterface
      *Addr = PeekI(*ptrInterface)
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
        *Addr = PeekI(*Addr + 16)
        CompilerElse
        *Addr = PeekI(*Addr + 8)
        CompilerEndIf
      CallFunctionFast(*Addr, *ptrInterface)
      EndIf
    EndProcedure
  
  Procedure.i OleLoadPictureFromHGlobal(*Mem, Size.i)
  ;OLELoadPictureFromString(ByVal PicData As String, ByRef hBitmap As Long) As Long
    ;Define.i xLong1 As Long
    ;Define *lpMem
    ;Dim xLongA1.i(4)
    Define.i hBmp
    Define *IStream
    Define *IPicture
    Define.i xLong1
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    Dim xLongA1.l(7)
CompilerElse
    Dim xLongA1.l(6)
CompilerEndIf
    If CreateStreamOnHGlobal_(*Mem, 1, @*IStream) = 0
      If *IStream
        xLongA1(0) = $7BF80980 ;"{7BF80980-BF32-101A-8BBB-00AA00300CAB}"
        xLongA1(1) = $101ABF32
        xLongA1(2) = $AA00BB8B
        xLongA1(3) = $AB0C3000
        If OleLoadPicture_(*IStream, Size, 0, @xLongA1(0), @*IPicture) = 0
          If *IPicture
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
            If OLEInterface_CallFunction1(*IPicture, 24, @xLong1) = 0
CompilerElse
            If OLEInterface_CallFunction1(*IPicture, 12, @xLong1) = 0
CompilerEndIf
              If xLong1
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
                If GetObject_(xLong1, 32, @xLongA1(0))
CompilerElse
                If GetObject_(xLong1, 28, @xLongA1(0))
CompilerEndIf
                  If xLongA1(1) And xLongA1(2)
                    hBmp = CopyImage_(xLong1, 0, xLongA1(1), xLongA1(2), $2000)
                    ;DeleteObject_(xLong1)
                    EndIf
                  EndIf
                EndIf
              EndIf
            OLEInterface_Release(*IPicture)
            EndIf
          EndIf
        OLEInterface_Release(*IStream)
        EndIf
      EndIf
;Debug "OleLoadPictureFromHGlobal: " + Str(hBmp)
    ProcedureReturn hBmp
    EndProcedure
  
  Procedure.i OLELoadPictureFromMem(*Mem, DataLen.i)
    Define *MemGP
    Define *MemLk
    Define.i hBmp
  
    *MemGP = GlobalAlloc_(2, DataLen)
    If *MemGP
      *MemLk = GlobalLock_(*MemGP)
      If *MemLk
        RtlMoveMemory_(*MemLk, *Mem, DataLen)
        GlobalUnlock_(*MemGP)
        hBmp = OLELoadPictureFromHGlobal(*MemGP, DataLen)
        EndIf
      GlobalFree_(*MemGP)
      EndIf
;Debug "OLELoadPictureFromMem: " + Str(hBmp)
    ProcedureReturn hBmp
    EndProcedure
  
  Procedure.i OLELoadPictureFromRes(ResType.s, ResID.s)
    Define.i xLong1
    Define.i xLong2
    Define.i DataLen
    Define.i xLong4
    ;Define.i hInstance
    Define *OLEPicture
  
    ;hInstance = GetModuleHandle_(0)
    ;If hInstance
      xLong1 = FindResource_(hInstance, ResID, resType)
      If xLong1
        xLong2 = LoadResource_(hInstance, xLong1)
        If xLong2
          DataLen = SizeofResource_(hInstance, xLong1)
          If DataLen
            xLong4 = LockResource_(xLong2)
            If xLong4
              *OLEPicture = OLELoadPictureFromMem(xLong4, DataLen)
              EndIf
            EndIf
          EndIf
        EndIf
      ;EndIf
;Debug "OLELoadPictureFromRes: " + Str(*OLEPicture) + " from " + Str(xLong4) + " size " + Str(DataLen)
    ProcedureReturn *OLEPicture
    EndProcedure
  CompilerEndIf

Procedure.i LoadResEx_Data(resFileName.s, resType.s)
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.i xLong4
  Define.i xLong5
      
  xLong1 = FindResource_(hInstance, resFileName, resType)
  If xLong1
    xLong2 = LoadResource_(hInstance, xLong1)
    If xLong2
      xLong3 = SizeofResource_(hInstance, xLong1)
      If xLong3
        xLong4 = LockResource_(xLong2)
        If xLong4
          xLong5 = LocalAlloc_(0, xLong3)
          If xLong5
            RtlMoveMemory_(xLong5, xLong4, xLong3)
            EndIf
          EndIf
        EndIf
      EndIf
    EndIf
;Debug "LoadResEx_Data: " + Str(xLong5)
  ProcedureReturn xLong5
  EndProcedure

CompilerIf #JPGWPRes
Procedure GetDims(hBmp.i)
  ;Debug "GetDims"
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    Dim xLongA1.l(7)
    CompilerElse
    Dim xLongA1.l(6)
    CompilerEndIf
CompilerElse
Procedure GetDims(*hBmpLD.BITMAPINFOHEADER)
CompilerEndIf
  Define.l CropSX
  Define.l CropSY
  Define.l CropFX
  Define.l CropFY
  Define.l T1
  Define.l T2
  Define.l EyeFixPosX
  Define.l EyeFixPosY
  
  CompilerIf #StereoBMP
    Define.l WallBmpWidth = #WallBmpWidth
    Define.l WallBmpHeight = #WallBmpHeight
    CompilerElse
    Define.l WallBmpWidth = #WallBmpWidth
    Define.l WallBmpHeight = #WallBmpHeight

    CompilerIf #JPGWPRes
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
      If GetObject_(hBmp, 32, @xLongA1(0))
CompilerElse
      If GetObject_(hBmp, 28, @xLongA1(0))
CompilerEndIf
        If xLongA1(1) And xLongA1(2)
          WallBmpWidth = xLongA1(1)
          WallBmpHeight = xLongA1(2)
          EndIf
        EndIf

      CompilerElse
      If *hBmpLD
        WallBmpWidth = *hBmpLD\biWidth
        WallBmpHeight = *hBmpLD\biHeight
  ;Debug "SuccessLoad"
  ;Debug WallBmpWidth
  ;Debug WallBmpHeight
        EndIf
      CompilerEndIf

    CompilerEndIf
  
  ;#MarginTop = 0
  ;#MarginLeft = 0
  ;#MarginRight = 0
  ;#MarginBottom = 0
  ;
  ;#BarPosManual = 0
  ;; or 
  ;#BarPos = 3 ; left, 1 = center, 2 = right, 3 = top, 4 = middle, 5 = bottom
  ;#BarOffset = 0 ;+/- x -> position offset, $80000000 = custom
  ;#PicPos = 5 ; numpad stype
  ;#PicStretch = 0 ; 0 = fit - 100 = stretchcut

CompilerIf #HAlign = 1
  ;InfoWidthGen = LastDeskPos\Bottom
  CompilerElse
  ;InfoWidthGen = LastDeskPos\Right
  CompilerEndIf

CompilerIf #OnPicRender
  RenderWidth = LastDeskPos\Right
  RenderHeight = LastDeskPos\Bottom
  CompilerElse
  RenderLeft = #MarginLeft
  RenderTop = #MarginTop
  RenderWidth = LastDeskPos\Right - #MarginLeft - #MarginRight
  RenderHeight = LastDeskPos\Bottom - #MarginTop - #MarginBottom
  CompilerEndIf

  ;#BarPos = 3 ; left, 1 = center, 2 = right, 3 = top, 4 = middle, 5 = bottom
  ;#BarOffset = 0 ;+/- x -> position offset, $80000000 = custom

;  CompilerEndIf

  ;CropFX = 
  ;CropFY

  If WallBmpWidth / WallBmpHeight > RenderWidth / RenderHeight
    ; fit with broad, strecht to fit height
InterW:
;Debug "Mode1"
;    Debug "StretchW; " + Str(WallBmpWidthOX)
    CropSX = (WallBmpWidth - WallBmpHeight * RenderWidth / RenderHeight) * #PicStretch / 100
CompilerIf #OnPicRender
CompilerElse
    If CropSX > #WallBmpWidthOX: CropSX = #WallBmpWidthOX: EndIf
CompilerEndIf
    If CropSX < 0: Goto InterV: EndIf
    ;If CropSX < 0: CropSX = 0: EndIf
    CropSY = 0
    SrcMarginWidth = WallBmpWidth - CropSX
    SrcMarginHeight = WallBmpHeight
    ;TX = RenderWidth ; SrcMarginWidth * RenderHeight / SrcMarginHeight
    T1 = RenderWidth * WallBmpHeight / SrcMarginWidth
    T2 = RenderHeight - T1
    SrcMarginTop = 0
CompilerIf #OnPicRender
    RenderLeft = 0
CompilerEndIf
    ;RenderWidth = 
    Select #PicPos
      Case 1,4,7
        SrcMarginLeft = 0
      Case 2,5,8
        SrcMarginLeft = CropSX / 2
      Case 3,6,9
        SrcMarginLeft = CropSX
      EndSelect
    Select #PicPos
      Case 7,8,9
        RenderTop = 0
      Case 4,5,6
        RenderTop = T2 / 2
      Case 1,2,3
        RenderTop = T2
      EndSelect
    RenderHeight = T1
    Else
InterV:
;Debug "Mode2"
;    Debug "StretchV"
    CropSY = (WallBmpHeight - WallBmpWidth * RenderHeight / RenderWidth) * #PicStretch / 100
;Debug CropSY
CompilerIf #OnPicRender
CompilerElse
    If CropSY > #WallBmpWidthOY: CropSY = #WallBmpWidthOY: EndIf
CompilerEndIf
    If CropSY < 0: Goto InterW: EndIf
;    If CropSY < 0: CropSY = 0: EndIf
    CropSX = 0
    SrcMarginHeight = WallBmpHeight - CropSY
    SrcMarginWidth = WallBmpWidth
    T1 = RenderHeight * WallBmpWidth / SrcMarginHeight
    T2 = RenderWidth - T1
    SrcMarginLeft = 0
CompilerIf #OnPicRender
    RenderTop = 0
CompilerEndIf
    ;RenderHeight = 
    Select #PicPos
      Case 7,8,9
        SrcMarginTop = 0
      Case 4,5,6
        SrcMarginTop = CropSY / 2
      Case 1,2,3
        SrcMarginTop = CropSY
      EndSelect
    Select #PicPos
      Case 1,4,7
        RenderLeft = 0
      Case 2,5,8
        RenderLeft = T2 / 2
      Case 3,6,9
        RenderLeft = T2
      EndSelect
    RenderWidth = T1
    EndIf
;Debug "CropS: " + Str(CropSX) + " / " + Str(CropSY)
;Debug "Src: " + Str(SrcMarginLeft) + " / " + Str(SrcMarginTop) + " - " + Str(SrcMarginWidth) + " / " + Str(SrcMarginHeight)
;Debug "Dest: " + Str(RenderLeft) + " / " + Str(RenderTop) + " - " + Str(RenderWidth) + " / " + Str(RenderHeight)

  CompilerIf #CustomPeakRender
    CompilerIf #CustomPeakInnerSize
      ResizedSelfPart()
      CompilerElse
      RenderInnerHeight = (RenderHeight * #CustomPeakSizeMul) / #CustomPeakSizeDiv + #CustomPeakSizePlus
      RenderInnerTop = (RenderHeight - RenderInnerHeight) / 2; + #BarOffset
      CompilerEndIf
    CompilerSelect #BarPos
      CompilerCase 3: InfoTop = #BarOffset
      CompilerCase 4: InfoTop = (RenderInnerHeight - #InfoIntHeight) / 2 + #BarOffset
      CompilerCase 5: InfoTop = RenderInnerHeight - #InfoIntHeight + #BarOffset
      CompilerEndSelect
    CompilerElse
    CompilerSelect #BarPos
      CompilerCase 0: InfoLeft = #BarOffset
      CompilerCase 1: InfoLeft = (LastDeskPos\Right - 48) / 2 + #BarOffset
      CompilerCase 2: InfoLeft = LastDeskPos\Right - 48 + #BarOffset
      CompilerCase 3: InfoTop = #BarOffset
      CompilerCase 4: InfoTop = (LastDeskPos\Bottom - #InfoIntHeight) / 2 + #BarOffset
      CompilerCase 5: InfoTop = LastDeskPos\Bottom - #InfoIntHeight + #BarOffset
      CompilerEndSelect
    CompilerEndIf

;Global SrcMarginLeft.l
;Global SrcMarginTop.l

CompilerIf #OnPicRender
CompilerElse
;CompilerIf 0
  ClearRectTop\Bottom = RenderTop
  ClearRectTop\Right = LastDeskPos\Right
  ClearRectBottom\Top = RenderTop + RenderHeight
  ClearRectBottom\Bottom = LastDeskPos\Bottom
  ClearRectBottom\Right = LastDeskPos\Right
  ClearRectLeft\Top = RenderTop
  ClearRectLeft\Right = RenderLeft
  ClearRectLeft\Bottom = RenderTop + RenderHeight
;CompilerEndIf
  ClearRectRight\Top = RenderTop
  ClearRectRight\Left = RenderLeft + RenderWidth
  ClearRectRight\Right = LastDeskPos\Right
  ClearRectRight\Bottom = RenderTop + RenderHeight
;CompilerIf 0
;CompilerEndIf


    CompilerSelect #PicPos
      CompilerCase 1
      CompilerCase 2
      CompilerCase 3
      CompilerCase 4
      CompilerCase 5
      CompilerCase 6
      CompilerCase 7
      CompilerCase 8
      CompilerCase 9
      CompilerEndSelect
CompilerEndIf


CompilerIf #StereoBMP
    ExtraBmp1Left = (#ExtraBmp1Left - SrcMarginLeft) * RenderWidth / SrcMarginWidth
    ExtraBmp1Top = (#ExtraBmp1Top - SrcMarginTop) * RenderHeight / SrcMarginHeight
    ExtraBmp1Width = (#ExtraBmp1WidthX * RenderWidth) / SrcMarginWidth
    ExtraBmp1Height = (#ExtraBmp1HeightX * RenderHeight) / SrcMarginHeight
CompilerIf #StereoBMP = 2
    ExtraBmp2Left = (#ExtraBmp2Left - SrcMarginLeft) * RenderWidth / SrcMarginWidth
    ExtraBmp2Top = (#ExtraBmp2Top - SrcMarginTop) * RenderHeight / SrcMarginHeight
    ExtraBmp2Width = (#ExtraBmp2WidthX * RenderWidth) / SrcMarginWidth
    ExtraBmp2Height = (#ExtraBmp2HeightX * RenderHeight) / SrcMarginHeight
CompilerEndIf
CompilerEndIf
CompilerIf #JPGWPRes
  EndProcedure
CompilerElse
  EndProcedure
CompilerEndIf

Procedure ResizedSelf()
  CompilerIf #JPGWPRes
    ;Define.i xDataIPM
    CompilerElse
    Define.i xData ;xLong1
    Define.i xData2 ;xLong2
    CompilerEndIf
  Define.i hDC ;xLong3
  ;Define.l xLong4
  Define.i hBmp ; xLong5
  ;Define.l xLong6
  Define.i hBmp2 ; xLong7
  Define.l Success
  Define.BITMAPINFOHEADER *xType1
CompilerIf #OnPicRender
  CompilerIf #AlphaBackColor = -1
    CompilerElse
    Define.i hBrushAB
    CompilerEndIf
    
  CompilerIf #HideText
    CompilerElse
    Define.RECT xType2
    Define.RECT xType3
    ;Define.l Success2
    CompilerEndIf
  CompilerEndIf

  CompilerIf #StereoBMP
    CompilerElse
    CompilerIf #ClearOldInfoBmp
      CompilerElse
      OneTimeClearOldInfoBmp = #True
      CompilerEndIf
    CompilerEndIf

  CompilerIf #CustomPeakRender
    CompilerElseIf #StereoBMP
    CompilerElse
    PeaksCXX = -1
    CompilerEndIf

  If hBmpOld3
    SelectObject_(hDCTemp3, hBmpOld3)
    DeleteObject_(hBmp3)
    hBmpOld3 = 0
    EndIf


;Debug "ResizedSelf"

  If LastDeskPos\Bottom
      CompilerIf #JPGWPRes
      CompilerIf #StereoBMP
        hBmp = OLELoadPictureFromRes("JPG", "background")
        CompilerElse
        hBmp = OLELoadPictureFromRes("JPG", "wallpaper")
        CompilerEndIf
      If hBmp
        GetDims(hBmp)
        EndIf
;Debug "Bmp: " + Str(hBmp)
      CompilerElse
      CompilerIf #StereoBMP
        xData = LoadResEx_Data("background", "#2")
        CompilerElse
        xData = LoadResEx_Data("wallpaper", "#2")
        CompilerEndIf
      GetDims(xData)
      CompilerEndIf


    CompilerIf #StereoBMP
      CompilerElseIf #CustomPeakRender
      ParticleCenterX = RenderWidth / 2
      ParticleCenterY = RenderInnerHeight / 2
      CompilerIf #PartID = 51885
        If ParticleCenterX > ParticleCenterY ;MaxSize
          MaxSize = ParticleCenterX ;* 1.6;1.4142135623731
          Else
          MaxSize = ParticleCenterY ;* 1.6;1.4142135623731
          EndIf
        CompilerEndIf
      CompilerElse
      PeaksCX = (RenderWidth - #PeakW) / #PeakDW
      PeaksCXX = PeaksCX - 1
      SizeTX = (PeaksCX - 1) * #PeakDW + #PeakW
      LeftPos = (RenderWidth - SizeTX) / 2
      CompilerEndIf


    hDC = GetDC_(xMainHWnd)
    If hDC
      CompilerIf #CustomPeakRender
        hBmp3 = CreateCompatibleBitmap_(hDC, RenderWidth, RenderInnerHeight)
        CompilerElseIf #SpectrumRedrawInfo Or #StereoBMP
        hBmp3 = CreateCompatibleBitmap_(hDC, RenderWidth, #InfoIntHeight)
        CompilerElse
        hBmp3 = CreateCompatibleBitmap_(hDC, SizeTX, #InfoIntHeight)
        CompilerEndIf
      If hBmp3
        hBmpOld3 = SelectObject_(hDCTemp3, hBmp3)
        If Not hBmpOld3
          DeleteObject_(hBmp3)
          EndIf
        EndIf
CompilerIf #JPGWPRes
CompilerElse
      If xData
        *xType1 = xData
        Select *xType1\biBitCount
          Case 24: xData2 = xData + 40
          Case 8: xData2 = xData + 1064
          Case 4: xData2 = xData + 104
          EndSelect
        If xData2
          If SelectObject_(hDCTemp, hBmpOld2)
            hBmp = CreateCompatibleBitmap_(hDC, *xType1\biWidth, *xType1\biHeight)
            If hBmp
;Debug "4"
              If SetDIBits_(hDCTemp, hBmp, 0, *xType1\biHeight, xData2, xData, 0)
;Debug "5"
CompilerEndIf
                If SelectObject_(hDCTemp, hBmp)
;Debug "6"
                  hBmp2 = CreateCompatibleBitmap_(hDC, RenderWidth, RenderHeight)
                  If hBmp2
;Debug "7"
                    If SelectObject_(hDCTemp2, hBmp2)
;Debug "8"
                      ;If IsUnicode
;;;;                        SetStretchBltMode_(hDCTemp, #COLORONCOLOR)
                        SetStretchBltMode_(hDCTemp2, #HALFTONE)
                      ;  Else
;                        SetStretchBltMode_(hDCTemp2, #HALFTONE)
                      ;  EndIf
;                        If StretchBlt_(hDCTemp2, 0, 0, (LastDeskPos\Right - LastDeskPos\Left), RenderHeight, xLong4, 0, 0, ExtraBmpCopyWX, #WallBmpHeight, #SRCCOPY)
                      SetBrushOrgEx_(hDCTemp2, 0, 0, 0)
                      ;If StretchBlt_(hDCTemp2, 0, 0, RenderWidth, RenderHeight, hDCTemp, 0, 0, #WallBmpWidth, #WallBmpHeight, #SRCCOPY)
                      If StretchBlt_(hDCTemp2, 0, 0, RenderWidth, RenderHeight, hDCTemp, SrcMarginLeft, SrcMarginTop, SrcMarginWidth, SrcMarginHeight, #SRCCOPY)
;Debug "9"
                        If hBmp1
                          DeleteObject_(hBmp1)
                          EndIf
CompilerIf #OnPicRender
CompilerIf #HideText
CompilerElse
                        CompilerIf #CustomPeakRender
                          xType2\Right = RenderWidth
                          xType2\Top = RenderInnerTop
                          xType2\Bottom = RenderInnerTop + RenderInnerHeight
                          xType3\Right = RenderWidth
                          xType3\Bottom = RenderInnerHeight
                          CompilerElseIf #HAlign = 1
                          xType2\Right = RenderWidth
                          xType2\Top = InfoTop
                          xType2\Bottom = InfoTop + #InfoIntHeight
                          xType3\Right = RenderWidth
                          xType3\Bottom = #InfoIntHeight
                          CompilerElse
                          xType2\Bottom = RenderHeight
                          xType2\Left = InfoLeft
                          xType2\Right = InfoLeft + 48; InfoLeft + InfoWidthMax; - InfoWidth
                          xType3\Right = 48
                          xType3\Bottom = RenderHeight
                          CompilerEndIf
                        If ptrAlphaBlend
;Debug "a1"
                          IsAlpha = 0
                          hBmp1 = CreateCompatibleBitmap_(hDC, xType3\Right, xType3\Bottom)
                          If hBmp1
;Debug "a2"
                            If SelectObject_(hDCTemp, hBmp1)
;Debug "a3"
CompilerIf #AlphaBackColor = -1
                              If FillRect_(hDCTemp, @xType3, hBrush)
                                IsAlpha = CallFunctionFast(ptrAlphaBlend, hDCTemp2, xType2\Left, xType2\Top, xType3\Right, xType3\Bottom, hDCTemp, 0, 0, xType3\Right, xType3\Bottom, #OnPicRender)
                                EndIf
CompilerElse
                              hBrushAB = CreateSolidBrush_(#AlphaBackColorRealRGB)
                              If hBrushAB
                                If FillRect_(hDCTemp, @xType3, hBrushAB)
                                  IsAlpha = CallFunctionFast(ptrAlphaBlend, hDCTemp2, xType2\Left, xType2\Top, xType3\Right, xType3\Bottom, hDCTemp, 0, 0, xType3\Right, xType3\Bottom, #OnPicRender)
                                  EndIf
                                DeleteObject_(hBrushAB)
                                EndIf
CompilerEndIf
;Debug "a4"
;Debug xType2\Left
;Debug xType2\Top
;Debug xType3\Right
;Debug xType3\Bottom
;If IsAlpha
;  Debug "a4"
;  EndIf

                              SelectObject_(hDCTemp, hLSBmpOld)
                              EndIf
                            DeleteObject_(hBmp1)
                            EndIf
                          EndIf
                        ;IsAlpha = 0
                        If IsAlpha = 0
                          If #OnPicRender > $480000
                            CompilerIf #AlphaBackColor = -1 Or (#AlphaBackColor & $C0C0C0)
                              FillRect_(hDCTemp2, xType2, hBrush)
                              CompilerElse
                              hBrushAB = CreateSolidBrush_(#AlphaBackColorRealRGB)
                              If hBrushAB
                                FillRect_(hDCTemp2, xType2, hBrushAB)
                                DeleteObject_(hBrushAB)
                                EndIf
                              CompilerEndIf
                            Else
                            IsAlpha = 1
                            EndIf
                          EndIf
CompilerEndIf
CompilerEndIf
                        hBmp1 = hBmp2
;Debug "Success"
                        Success = 1
                        EndIf
                      ;If IsUnicode = 0
;                        SetStretchBltMode_(hDCTemp2, #COLORONCOLOR)
                      ;  SetStretchBltMode_(hDCTemp2, #COLORONCOLOR)
  ;                   ;   SelectObject_(hDCTemp2, hLSBmpOld)
                      ;  SetBrushOrgEx_(hDCTemp2, 0, 0, 0)
                      ;  EndIf
                      If Success = 0
                        SelectObject_(hDCTemp2, hBmp1)
                        EndIf
                      EndIf
                    If Success = 0
                      DeleteObject_(hBmp2)
                      ;hBmp1 = 0
                      ;Success = 0
                      EndIf
                    EndIf
                  ;SelectObject_(xLong4, xLong6)
                  SelectObject_(hDCTemp, hLSBmpOld)
                  EndIf
CompilerIf #JPGWPRes
  If hBmp
    DeleteObject_(hBmp)
    EndIf
CompilerElse
                EndIf
              DeleteObject_(hBmp)
              EndIf
            EndIf
          EndIf
        LocalFree_(xData)
        EndIf
CompilerEndIf
      ReleaseDC_(xMainHWnd, hDC)
      EndIf
  
    EraseBkGndSelf()
    EndIf

  CompilerIf #StereoBMP
    CompilerElse
    ;Define.i xLong4
    
    CompilerIf #CustomPeakRender
      CompilerElse
      If #HAlign
        BottomPos = InfoTop + #InfoIntHeight; - 40
        Else
        BottomPos = RenderHeight - 10
        EndIf
      If SpecData
        LocalFree_(SpecData)
        ;SpecData = 0
        EndIf
      CompilerIf #LEDMdWaveQuad
        LocalFree_(SpecData2)
        CompilerEndIf
      CompilerIf #LEDMdSpec
        CompilerElseIf #LEDMdHist
        If HistRect
          LocalFree_(HistRect)
          ;HistRect = 0
          EndIf
        If HistMult
          LocalFree_(HistMult)
          ;HistMult = 0
          EndIf
        CompilerEndIf
      CompilerIf #SpectrumColor = -1
        If PeaksCols
          LocalFree_(PeaksCols)
          EndIf
        CompilerEndIf
      CompilerIf #LEDMdSpec
        SpecData = LocalAlloc_(0, PeaksCX * 8)
        CompilerElseIf #LEDMdHist
        SpecData = LocalAlloc_(0, 2 * 8)
        HistRect = LocalAlloc_($40, PeaksCX * #lenHISTRECT + #lenHISTRECT) ; Zero!
        HistMult = LocalAlloc_(0, PeaksCX * 4 + 8)
        If HistMult
          Define.i xLong1
          Define.i xLong2 = HistMult
CompilerIf #False
          For xLong1 = 0 To Round(PeaksCXX * 3 / 4, #PB_Round_Down)
            PokeF(xLong2, Sin(xLong1 * 2 * #PI / PeaksCXX))
            ;PokeF(xLong2, 1)
            xLong2 + 4
            Next
          For xLong1 = Round(PeaksCXX * 3 / 4, #PB_Round_Down) To PeaksCXX
            PokeF(xLong2, 1)
            xLong2 + 4
            Next
CompilerElse
          #SinMd2 = 1
          #SinMd4 = 2
          For xLong1 = 0 To Round(PeaksCXX / #SinMd4, #PB_Round_Down)
            PokeF(xLong2, Sin(xLong1 * #SinMd2 * #PI / PeaksCXX))
            ;PokeF(xLong2, 1)
            xLong2 + 4
            Next
          For xLong1 = Round(PeaksCXX / #SinMd4, #PB_Round_Down) To PeaksCXX
            PokeF(xLong2, 1)
            xLong2 + 4
            Next
CompilerEndIf
          EndIf
        *HistRCur = HistRect
        HistRMax = HistRect + PeaksCX * #lenHISTRECT
        CompilerElseIf #LEDMdWaveDual Or #LEDMdWaveQuad
        SpecData = LocalAlloc_(0, PeaksCX * 8)
        CompilerIf #LEDMdWaveQuad
          SpecData2 = LocalAlloc_(0, PeaksCX * 8)
          CompilerEndIf
        CompilerElse
        SpecData = LocalAlloc_(0, PeaksCX * 4)
        CompilerEndIf
      CompilerIf #SpectrumColor = -1
        CompilerIf #ColorizedBackColor And #LEDMdSpec
          PeaksCols = LocalAlloc_(0, PeaksCX * 8+16)
          CompilerElse
          PeaksCols = LocalAlloc_(0, PeaksCX * 4 + 8)
          CompilerEndIf
        InitColors(PeaksCX)
        CompilerEndIf
      CompilerEndIf
    CompilerEndIf
  EndProcedure

;Procedure DMEnumDC(hMonitor.l, hDC.l, *ISRect.RECT, xParam.l)
;  If Not (*ISRect\Left + *ISRect\Top) = 0
;    xParam = CreateCompatibleDC_(hDC)
;    If xParam
;      If hDCTemp
;        DeleteDC_(hDCTemp)
;        EndIf
;      hDCTemp = xParam
;      EndIf
;    EndIf
;  ProcedureReturn 1
;  EndProcedure

Procedure.l InitSelf()
  Define.i hDC ; xLong3
  Define.i hDesk
  CompilerIf #StereoBMP
    Define.BITMAPINFOHEADER *xType2a
    CompilerIf #StereoBMP = 2
      Define.BITMAPINFOHEADER *xType2b
      CompilerEndIf
    CompilerEndIf

CompilerIf #OnPicRender
  CompilerIf #HideText
    CompilerElse
    ptrAlphaBlend = LoadLibrary_("msimg32.dll")
    If ptrAlphaBlend
      ptrAlphaBlend = GetProcAddress(ptrAlphaBlend, "AlphaBlend")
      EndIf
    CompilerEndIf
  CompilerEndIf

CompilerIf #StereoBMP
CompilerIf #StereoBMP = 2
    hData1a = LoadResEx_Data("eyel", "#2")
    If hData1a
      hData1b = LoadResEx_Data("eyer", "#2")
      If hData1b
CompilerElse
    hData1a = LoadResEx_Data("eye", "#2")
    If hData1a
CompilerEndIf


    *xType2a = hData1a
    Select *xType2a\biBitCount
      Case 8: hData2a = hData1a + 1064
      Case 4: hData2a = hData1a + 104
      EndSelect
    If hData2a

CompilerIf #StereoBMP = 2
    *xType2b = hData1b
    Select *xType2b\biBitCount
      Case 8: hData2b = hData1b + 1064
      Case 4: hData2b = hData1b + 104
      EndSelect
    If hData2a
CompilerEndIf
CompilerEndIf

      hDC = GetDC_(xMainHWnd)
      If hDC
        ;hDCTemp = CreateCompatibleDC_(xLong3)
        ;If hDCTemp
          hDCTemp2 = CreateCompatibleDC_(hDC)
          If hDCTemp2
            ;hLSBmpOld = GetCurrentObject_(hDCTemp, #OBJ_BITMAP)
            ;If hLSBmpOld
            hDCTemp3 = CreateCompatibleDC_(hDC)
            If hDCTemp3
CompilerIf #StereoBMP
                  hBmp2a = CreateCompatibleBitmap_(hDC, *xType2a\biWidth, *xType2a\biHeight)
                  If hBmp2a
                    hBmpOld2 = GetCurrentObject_(hDCTemp2, #OBJ_BITMAP)
                    If hBmpOld2
                      RtlMoveMemory_(@xPal1(0), hData1a + 40, #PalCountRMM)
                      hDatabiHeight1 = *xType2a\biHeight
CompilerIf #StereoBMP = 2
                      hBmp2b = CreateCompatibleBitmap_(hDC, *xType2b\biWidth, *xType2b\biHeight)
                      If hBmp2b
                        RtlMoveMemory_(@xPal2(0), hData1b + 40, #PalCountRMM)
                        hDatabiHeight2 = *xType2b\biHeight
CompilerEndIf
CompilerElse
                hBmpOld2 = GetCurrentObject_(hDCTemp2, #OBJ_BITMAP)
                If hBmpOld2
CompilerEndIf
                      ReleaseDC_(0, hDC)
;Debug "SuccessFully"
                      ProcedureReturn 1
CompilerIf #StereoBMP
CompilerIf #StereoBMP = 2
                        DeleteObject_(hBmp2b)
                        hBmp2b = 0
                        EndIf
CompilerEndIf
                      EndIf
                    DeleteObject_(hBmp2a)
                    hBmp2a = 0
                    EndIf
                  ;EndIf
CompilerElse
              EndIf
CompilerEndIf
              DeleteDC_(hDCTemp3)
              hDCTemp3 = 0
              EndIf
            DeleteDC_(hDCTemp2)
            hDCTemp2 = 0
            EndIf
          ;DeleteDC_(hDCTemp)
          ;hDCTemp = 0
          ;EndIf
        ReleaseDC_(xMainHWnd, hDC)
        EndIf
CompilerIf #StereoBMP
CompilerIf #StereoBMP = 2
      EndIf
CompilerEndIf
      EndIf
CompilerIf #StereoBMP = 2
    LocalFree_(hData1b)
    EndIf
CompilerEndIf
    LocalFree_(hData1a)
    EndIf
CompilerEndIf
  EndProcedure

Procedure TerminateSelf()
  If hBmpOld3
    SelectObject_(hDCTemp3, hBmpOld3)
    DeleteObject_(hBmp3)
    hBmpOld3 = 0
    EndIf
  SelectObject_(hDCTemp2, hBmpOld2)
  SelectObject_(hDCTemp, hLSBmpOld)
  CompilerIf #StereoBMP
    DeleteObject_(hBmp2a)
    CompilerIf #StereoBMP = 2
      DeleteObject_(hBmp2b)
      CompilerEndIf
     CompilerEndIf
  DeleteDC_(hDCTemp3)
  DeleteObject_(hBmp1)
  DeleteDC_(hDCTemp2)
  ;DeleteDC_(hDCTemp)
  CompilerIf #StereoBMP
    LocalFree_(hData1a)
    CompilerIf #StereoBMP = 2
      LocalFree_(hData1b)
      CompilerEndIf
    CompilerElseIf #CustomPeakRender
    CompilerElse
    If SpecData
      LocalFree_(SpecData)
      CompilerIf #LEDMdWaveQuad
        LocalFree_(SpecData2)
        CompilerEndIf
      EndIf
    CompilerIf #LEDMdSpec
      CompilerElseIf #LEDMdHist
      If HistRect
        LocalFree_(HistRect)
        EndIf
      If HistMult
        LocalFree_(HistMult)
        EndIf
      CompilerEndIf

    CompilerIf #SpectrumColor = -1
      If PeaksCols
        LocalFree_(PeaksCols)
        EndIf
      CompilerEndIf
    CompilerEndIf
  EndProcedure

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 663
; FirstLine = 648
; Folding = ----------------------------------
; EnableAsm
; Executable = ..\..\..\Temp\tmp_wscx.exe
; CompileSourceDirectory
; IncludeVersionInfo
; AddResource = D:\DEV\Software\Libraries\LineSpec\LSDemo.rc