EnableExplicit

#LEDMode = $ff00

#CustomPeakRender = #True
#CustomPeakInnerSize = #False
#CustomPeakSizeMul = 6
#CustomPeakSizeDiv = 8
#CustomPeakSizePlus = 0
#ClearOldInfoBmp = #True
#OnPicRender = $680000 ; misuse $00xxxx / $000001 for full trans, $ff0000 for full black
#AlphaBackColor = $160500
#MMonitor = 1
#WarnMsg = #False
#WallBmpWidth = 1920
#WallBmpHeight = 1080
#PicSizeYOX = 300
#PicPos = 5
#PartID = 51885 ; stars/encircle
#MaxTick = $8000
#BarPos = 4
#BarOffset = 0
#BlackenTextBack = #True
Global MaxSize.l

#ProgressColorCur = $D1B098
#ProgressColorTot = $706040


#LargePeaks = 1
#PeaksCountMax = 20 ;1024;256
#PeaksCountMaxX = #PeaksCountMax - 1
#PeaksCountMaxP = #PeaksCountMax + 1
#PeaksCountMaxP2 = #PeaksCountMax + 2
#PeaksCountMaxStereoAS = #PeaksCountMax * 2 - 1

#ParticleRenderCountMax = #PeaksCountMax * 2
#ParticleRenderCountMaxX = #ParticleRenderCountMax - 1


#LargeRects = 1



;#RenderMainInfoMySelf = 2 ; 1 = yes, 2=yes with transparency!!!
;CompilerIf #RenderMainInfoMySelf = 2
  ;Global TransparentCenterMul.f = 0.66
  ;CompilerEndIf

;#PI2 = 2 * #PI ;3.1415926536 * 2
Global Dim xCurSpec.f(#PeaksCountMaxStereoAS)
Global Dim xOptSpec.f(#PeaksCountMaxStereoAS)
;Macro xOptSpec(Index)
  ;xCurSpec(Index)
  ;EndMacro
Global Dim xCurBeat.f(1)
Global Dim PreX.l(#PeaksCountMax)
Global Dim PreY.l(#PeaksCountMaxX)

Declare RenderSelfPart(SkipFrame.l, xElapsedTicks.l)
Declare InitCircles()
Global Dim DefColors(#PeaksCountMaxX)
InitCircles()

IncludeFile "LSDemo (Wallpaper).pb"

Procedure InitColorsFadingEx(VersionMode.i, IDFrom, IDWidth, Color1, Color2)
  Define.i ICFE_Width = IDWidth
  Define.i ICFE_WidthX = IDWidth - 1
  Define.i ICFE_xCounter

  Define.i ICFE_Red1 =  Color1 >> 16
  Define.i ICFE_Grn1 = (Color1 & $ff00)
  Define.i ICFE_Blu1 = (Color1 & $ff) << 16

  Define.i ICFE_Red2 =  Color2 >> 16
  Define.i ICFE_Grn2 = (Color2 & $ff00)
  Define.i ICFE_Blu2 = (Color2 & $ff) << 16
  Define.i ICFE_Pointer

  If VersionMode = 2
    ;Define.f RGBMixCodeVar1_#ID = $ff / ICFE_WidthX / Sqr(Sqr(ICFE_WidthX))
    Define.f IFCE_MixDiv = $ff / ICFE_WidthX / Sqr(Sqr(ICFE_WidthX))
    EndIf


  For ICFE_xCounter = 0 To ICFE_WidthX
    If VersionMode = 2
      Define.i ICFE_MixFactor1 = (ICFE_xCounter * Sqr(Sqr(ICFE_xCounter)) * IFCE_MixDiv)
      Else
      Define.i ICFE_MixFactor1 = (ICFE_xCounter * 255) / ICFE_WidthX
      EndIf
    Define.i ICFE_MixFactor2 = 255 - ICFE_MixFactor1

    Define.i ICFE_xCol.i = (((ICFE_Red1 * ICFE_MixFactor2 + ICFE_Red2 * ICFE_MixFactor1) / 255) & $ff)
             ICFE_xCol   | (((ICFE_Grn1 * ICFE_MixFactor2 + ICFE_Grn2 * ICFE_MixFactor1) / 255) &   $ff00)
             ICFE_xCol   | (((ICFE_Blu1 * ICFE_MixFactor2 + ICFE_Blu2 * ICFE_MixFactor1) / 255) &     $ff0000)
    DefColors(IDFrom) = ICFE_xCol
    IDFrom + 1
    Next
  EndProcedure

Macro InitColorsBy2Colors(Mode, Color1, Color2)
  #ICFE_Color1#MacroExpandedCount = Color1
  #ICFE_Color2#MacroExpandedCount = Color2
  InitColorsFadingEx(Mode, 0, #PeaksCountMax, #ICFE_Color1#MacroExpandedCount, #ICFE_Color2#MacroExpandedCount)
  EndMacro

Macro InitColorsBy3Colors(Mode, Color1, Color2, Color3)
  Define.i SpecSizeHalf

  #ICFE_Color1#MacroExpandedCount = Color1
  #ICFE_Color2#MacroExpandedCount = Color2
  #ICFE_Color3#MacroExpandedCount = Color3
  SpecSizeHalf = (#PeaksCountMax + 1) >> 1
  InitColorsFadingEx(Mode, 0, SpecSizeHalf, #ICFE_Color1#MacroExpandedCount, #ICFE_Color2#MacroExpandedCount)
  InitColorsFadingEx(Mode, SpecSizeHalf, SpecSizeHalf, #ICFE_Color2#MacroExpandedCount, #ICFE_Color3#MacroExpandedCount)
  EndMacro

Procedure InitCircles()
  ;InitColorsBy3Colors(1, $0000ff, $00ff00, $ff0000)
  ;InitColorsBy3Colors(2, $5050ff, $50ff50, $ff5050)
  ;InitColorsBy3Colors(2, $275499, $00A843, $E02424)
  ;InitColorsBy3Colors(2, $878aed, $ffa025, $C020E8)
  ;InitColorsBy3Colors(2, $381516, $7F6C5A, $8F9EAD)
  InitColorsBy2Colors(2, $301510, $9F8C7A) ; $7F6C5A
  EndProcedure





Macro Floor(xTerm)
  Round((xTerm), #PB_Round_Down)
  EndMacro

Procedure RenderSelfPart(SkipFrame.l, xElapsedTicks.l)
  Define.l xLong1
  Define.i hxBrush
  Define.i hBrushOrg
  Define.i hBrushOld
  Define.i hxPen
  Define.i hPenOrg
  Define.i hPenOld
  Define.i MyMaxSize
  Define.i OffX
  Define.i OffY
  Define.RECT xType1
  Define.RECT xType2
  Define.s xChar1
  Define.i hFontOld

  Define.f Boost = 1.5 ; 1.5;00
  If SetWaveData(0)
    GetFullSpectrumStereoOpt(0)
    SpectrumCompactStereo(0, 1024, @xCurSpec(0), #PeaksCountMax)
    SpectrumCompactStereo(@xCurSpec(0), #PeaksCountMax, @xCurBeat(0), 1)
    For xLong1 = 0 To #PeaksCountMaxX
      xOptSpec(xLong1) = 0.25 + 0.75 * xCurSpec(xLong1) ;+ 0.15 * xCurBeat(0)
      xOptSpec(xLong1 + #PeaksCountMax) = 0.25 + 0.75 * xCurSpec(xLong1 + #PeaksCountMax) ;+ 0.15 * xCurBeat(1)
      ;xOptSpec(xLong1) = Sqr((xCurSpec(xLong1) * #PeaksCountMax) / (#PeaksCountMaxP2 + 8 - xLong1))  ;+ 0.15 * xCurBeat(0)
      ;xOptSpec(xLong1 + #PeaksCountMax) = Sqr((xCurSpec(xLong1 + #PeaksCountMax) * #PeaksCountMax) / (#PeaksCountMaxP2 + 8 - xLong1)) ;+ 0.15 * xCurBeat(1)
      ;xOptSpec(xLong1) = Sqr(Sqr(xCurSpec(xLong1)))
      ;xOptSpec(xLong1 + #PeaksCountMax) = Sqr(Sqr(xCurSpec(xLong1 + #PeaksCountMax)))
      Next
    EndIf

  hPenOrg = GetCurrentObject_(hDCTemp3, #OBJ_PEN)
  hBrushOrg = GetCurrentObject_(hDCTemp3, #OBJ_BRUSH)
  PreX(#PeaksCountMax) = PreX(0)
  ;hxPen = CreatePen_(#PS_NULL, 0, $000000)
  hPenOld = CreatePen_(#PS_SOLID, 1, $000000)
  hBrushOld = CreateSolidBrush_($000000)
  MyMaxSize = MaxSize / 3
  If hBrushOld
    If hPenOld
      ;hPenOrg = SelectObject_(hDCTemp3, hxPen)
      ;SetArcDirection_(hDCTemp3, #AD_CLOCKWISE)
      SetArcDirection_(hDCTemp3, #AD_COUNTERCLOCKWISE)
      xLong1 = (GetTickCount_() & $3fff)
      Define.f xFloat1 = Sin(xLong1 * #PI * 2 / $4000)
      If xFloat1 < 0
        Define.i xXRot = Sqr(-xFloat1) * xFloat1 * #PeaksCountMaxP * 1.9
        Else
        Define.i xXRot = Sqr(xFloat1) * xFloat1 * #PeaksCountMaxP * 1.9
        EndIf

Define.i xLong2
;xXRot = 0
For xLong2 = 0 To MyMaxSize / 20
      For xLong1 = 0 To #PeaksCountMaxX
        ;hxBrush = CreateSolidBrush_(DefColors(xLong1))
;If (xLong1 & 3) = 0
        If xLong2 = MyMaxSize / 20
          hxBrush = CreateSolidBrush_(DefColors(xLong1))
          Else
          hxBrush = CreateSolidBrush_((DefColors(xLong1) & $fefefe) >> 1)
          EndIf
        If hxBrush
          If xLong2 = MyMaxSize / 20
            hxPen = CreatePen_(#PS_SOLID, 1, DefColors(xLong1))
            Else
            hxPen = CreatePen_(#PS_SOLID, 1, (DefColors(xLong1) & $fefefe) >> 1)
            EndIf
          If hxPen
            SelectObject_(hDCTemp3, hxBrush)
            SelectObject_(hDCTemp3, hxPen)
            OffX = ParticleCenterX - MyMaxSize / 40 + xLong2 ;- Cos((xXRot + xLong1 + 0.5) * #PI / #PeaksCountMax) * 20
            OffY = ParticleCenterY - MyMaxSize / 40 + xLong2 ;- Sin((xXRot + xLong1 + 0.5) * #PI / #PeaksCountMax) * 20 ;- 24
            If xOptSpec(xLong1) > 0.75
              OffX - Cos((xXRot + xLong1 + 0.5) * #PI / #PeaksCountMax) * MyMaxSize / 5
              OffY - Sin((xXRot + xLong1 + 0.5) * #PI / #PeaksCountMax) * MyMaxSize / 5;- 24
              EndIf
            Pie_(hDCTemp3, OffX - MyMaxSize * xOptSpec(               xLong1), OffY - MyMaxSize * xOptSpec(               xLong1), OffX + MyMaxSize * xOptSpec(               xLong1), OffY + MyMaxSize * xOptSpec(               xLong1), OffX - Cos((xXRot + xLong1 +                                    1) * #PI / #PeaksCountMax) * MyMaxSize * 2, OffY - Sin((xXRot + xLong1 +                                    1) * #PI / #PeaksCountMax) * MyMaxSize * 2, OffX - Cos((xXRot + xLong1                                   ) * #PI / #PeaksCountMax) * MyMaxSize * 2, OffY - Sin((xXRot + xLong1                                  ) * #PI / #PeaksCountMax) * MyMaxSize * 2)
            OffX = ParticleCenterX - MyMaxSize / 40 + xLong2 ;- Cos((xXRot + #PeaksCountMaxX - xLong1 + #PeaksCountMax + 0.5) * #PI / #PeaksCountMax) * 20
            OffY = ParticleCenterY - MyMaxSize / 40 + xLong2 ;- Sin((xXRot + #PeaksCountMaxX - xLong1 + #PeaksCountMax + 0.5) * #PI / #PeaksCountMax) * 20;- 24
            If xOptSpec(xLong1 + #PeaksCountMax) > 0.75
              OffX - Cos((xXRot + #PeaksCountMaxX - xLong1 + #PeaksCountMax + 0.5) * #PI / #PeaksCountMax) * MyMaxSize / 5
              OffY - Sin((xXRot + #PeaksCountMaxX - xLong1 + #PeaksCountMax + 0.5) * #PI / #PeaksCountMax) * MyMaxSize / 5
              EndIf
            Pie_(hDCTemp3, OffX - MyMaxSize * xOptSpec(#PeaksCountMax+xLong1), OffY - MyMaxSize * xOptSpec(#PeaksCountMax+xLong1), OffX + MyMaxSize * xOptSpec(#PeaksCountMax+xLong1), OffY + MyMaxSize * xOptSpec(#PeaksCountMax+xLong1), OffX - Cos((xXRot + #PeaksCountMaxX - xLong1 + #PeaksCountMax + 1) * #PI / #PeaksCountMax) * MyMaxSize * 2, OffY - Sin((xXRot + #PeaksCountMaxX - xLong1 + #PeaksCountMax + 1) * #PI / #PeaksCountMax) * MyMaxSize * 2, OffX - Cos((xXRot + #PeaksCountMaxX - xLong1 + #PeaksCountMax) * #PI / #PeaksCountMax) * MyMaxSize * 2, OffY - Sin((xXRot + #PeaksCountMaxX - xLong1 + #PeaksCountMax) * #PI / #PeaksCountMax) * MyMaxSize * 2)
            DeleteObject_(hBrushOld)
            DeleteObject_(hPenOld)
            hBrushOld = hxBrush
            hPenOld = hxPen
            Else
            DeleteObject_(hxBrush)
            EndIf
          EndIf
;EndIf
        Next
Next
      SelectObject_(hDCTemp3, hPenOrg)
      DeleteObject_(hxPen)
      SelectObject_(hDCTemp3, hBrushOrg)
      DeleteObject_(hBrushOld)
      hFontOld = SelectObject_(hDCTemp3, hFontLarge)
      If hFontOld
        SetTextColor_(hDCTemp3, $ffffff)
        SetBkMode_(hDCTemp3, #TRANSPARENT)
        For xLong1 = 0 To #PeaksCountMaxX
        ;hxBrush = CreateSolidBrush_(DefColors(xLong1))
;If (xLong1 & 3) = 0
        hxBrush = CreateSolidBrush_((DefColors(xLong1) & $fefefe) >> 1)
        xType1\top = 10 + floor((xLong1 * (RenderInnerHeight - 20)) / #PeaksCountMax) + 4
        xType1\bottom = xType1\top + 18
        xType1\left = 40 - floor(Sqr(xCurSpec(xLong1) * 550) + 0.5) - 1
        xType1\right = 40 + floor(xCurSpec(xLong1) * 200 + 0.5) + 1
        xType2\top = xType1\top
        xType2\bottom = xType1\bottom
        xType2\left = RenderWidth -40 - floor(xCurSpec(#PeaksCountMax + xLong1) * 200 + 0.5) - 1
        xType2\right = RenderWidth -40 + floor(Sqr(xCurSpec(#PeaksCountMax + xLong1) * 550) + 0.5) + 1
        If hxBrush
          FillRect_(hDCTemp3, @xType1, hxBrush)
          FillRect_(hDCTemp3, @xType2, hxBrush)
          DeleteObject_(hxBrush)
          EndIf
        hxBrush = CreateSolidBrush_(DefColors(xLong1))
        If hxBrush
          xType1\top + 1
          xType1\bottom - 1
          xType1\left + 1
          xType1\right - 1
          FillRect_(hDCTemp3, @xType1, hxBrush)
          xType2\top + 1
          xType2\bottom - 1
          xType2\left + 1
          xType2\right - 1
          FillRect_(hDCTemp3, @xType2, hxBrush)
          DeleteObject_(hxBrush)
          EndIf
          Next
        SelectObject_(hDCTemp3, hFontOld)
        EndIf
      Else
      DeleteObject_(hBrushOld)
      EndIf
    EndIf
  EndProcedure


; IDE Options = PureBasic 5.22 LTS (Windows - x64)
; CursorPosition = 27
; Folding = --
; EnableAsm
; Executable = Simple spectrum x4.lpanim.dll
; CompileSourceDirectory
; IncludeVersionInfo
; AddResource = Wallpaper Ex - 3D Pie.rc