EnableExplicit

#LEDMode = 0
#ClearOldInfoBmp = #True
#CustomPeakInnerSize = #True
#PicSizeYOX = 300
;#CustomPeakRender = #True
#StereoBmp = 0
#MaxTick = #False
#PartID = 0
;#LEDMdSpec = #False
;#LEDMdBoost = 4
;#SpectrumColor = -1
#ColorizedBackColor = #False
;#OnPicRender = $680000 ; misuse $00xxxx / $000001 for full trans, $ff0000 for full black
#OnPicRender = $010000 ; misuse $00xxxx / $000001 for full trans, $ff0000 for full black
#AlphaBackColor = $ffff00
#BarPos = 5 ; 0=left, 1 = center, 2 = right, 3 = top, 4 = middle, 5 = bottom
#PicPos = 5 ; numpad stype
#WallBmpWidth = 1920 ; 2845 ; 1333
#WallBmpHeight = 1080 ; 1600 ; 1170 ; real height is 1224, but 1170 seems to be better
#WarnMsg = 1
#WarnQuit = 0 ;(5 * 60) * 1000
#SpectrumRedrawInfo = 1 ; recommend, required for #LEDMdSpec ?!?
#MMonitor = 0
;CompilerIf #SpectrumRedrawInfo
;  #PeaksCY = 120;16 ;10&
;  CompilerElse
;  #PeaksCY = 8 ;10&
;  CompilerEndIf
;#StereoBMP = 0
;#ColorizedBackColor = #True


;#MyPostScale = #True
#BarOffset = 0;-64;-16 ;+/- x -> position offset, $80000000 = custom
;  #BarOffset = (-127 * 768) / 1080;-64;-16 ;+/- x -> position offset, $80000000 = custom

Global Dim xSpecCur.f(19)
CompilerIf Not #ClearOldInfoBmp
  Global Dim xSpecLst.b(19)
  ;FillMemory(@xSpecLst(0), 20, #PB_Byte)
  Global xBrushBack.i = CreateSolidBrush_($303030)
  CompilerEndIf

Global xBrushFront.i = CreateSolidBrush_($c0c0c0)

#MaxPeaks = 7
DataSection
  xSpecMaxPk:
    Data.b 2, 2, 6, 6, 6, 6, 3, 2, 2, 2, 2, 2, 2, 2, 7, 2, 2, 5, 3, 2
  xSpecBoost:
    Data.f 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
  EndDataSection

Declare ResizedSelfPart()
Declare RenderSelfPart(SkipFrame.l);, xElapsedTicks.l)

IncludeFile "LSDemo (Wallpaper).pb"

If xBrushFront
  DeleteObject_(xBrushFront)
  EndIf
CompilerIf Not #ClearOldInfoBmp
  If xBrushBack
    DeleteObject_(xBrushBack)
    EndIf
  CompilerEndIf

Macro ScalePosX(PosX)
  ((PosX - SrcMarginLeft) * RenderWidth) / SrcMarginWidth
  EndMacro

Macro ScalePosY(PosY)
  ((PosY - SrcMarginTop) * RenderHeight) / SrcMarginHeight
  EndMacro

Macro ScaleRect(xRectSrc, xRectDest)
  xRectDest\Left   = ScalePosX(xRectSrc\Left)
  xRectDest\Top    = ScalePosY(xRectSrc\Top)
  xRectDest\Right  = ScalePosX(xRectSrc\Right)
  xRectDest\Bottom = ScalePosY(xRectSrc\Bottom)
  EndMacro

Macro ScaleRectToInner(xRectSrc, xRectDest)
  xRectDest\Left   = ScalePosX(xRectSrc\Left)
  xRectDest\Top    = ScalePosY(xRectSrc\Top) - RenderInnerTop
  xRectDest\Right  = ScalePosX(xRectSrc\Right)
  xRectDest\Bottom = ScalePosY(xRectSrc\Bottom) - RenderInnerTop
  EndMacro

Procedure RenderSelfPart(SkipFrame.l);, xElapsedTicks.l)
  Define.RECT xType1
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define *SpecCur
  Define *SpecMaxPK
  Define *SpecBoost
  Define.RECT xType2
  CompilerIf Not #ClearOldInfoBmp
    Define.i xLong4
    Define.i xLong5
    Define *SpecLst
    CompilerEndIf

  If xBrushFront
    *SpecMaxPK = ?xSpecMaxPk
    *SpecBoost = ?xSpecBoost
  
    #BoostStops = 20

    #SpacingX = 6
    #Spacingy = #SpacingX
    #PeekWidth = 60
    #PeekWidthP = #PeekWidth + #SpacingX
    #PeekHeight = 23
    #PeekHeightP = #PeekHeight + #SpacingY

    #PeekLeftestX = 505
    #PeekLeftestXP = #PeekLeftestX + #PeekWidth + 1
    #PeekBottommostY = 419
    #PeekBottommostYP = #PeekBottommostY + #PeekHeight
    #PeekAreaTop = #PeekBottommostY - (#MaxPeaks - 1) * #PeekHeightP
    #PeekAreaInnerHeight = #PeekBottommostY + #PeekHeight

 ;   #PeekInnerBottommostY = #PeekBottommostY - #PeekAreaTop
 ;   #PeekInnerBottommostYP = #PeekInnerBottommostY + #PeekHeight + 1

;Debug #PeekInnerBottommostY

    If SetWaveData(0)
      GetFullSpectrumMonoOpt(0)
      SpectrumCompactMono(0, 1024, @xSpecCur(0), 20)
      EndIf
  
  ;Debug xElapsedTicks
  
    *SpecCur = @xSpecCur(0)
    CompilerIf Not #ClearOldInfoBmp
      *SpecLst = @xSpecLst(0)
      CompilerEndIf
    xType1\Left = #PeekLeftestX
    xType1\Right = #PeekLeftestXP
    For xLong1 = 0 To 19
      ; 60 + 6 / 23 + 6

      CompilerIf #ClearOldInfoBmp
        xLong2 = PeekF(*SpecCur) * PeekF(*SpecBoost) * #BoostStops - 1
        xLong3 = PeekB(*SpecMaxPK) - 1
        If xLong2 > xLong3
          xLong2 = xLong3
          EndIf
        xType1\Top = #PeekBottommostY
        xType1\Bottom = #PeekBottommostYP; - #PeekAreaTop
        For xLong3 = 0 To xLong2
          ScaleRectToInner(xType1, xType2)
          FillRect_(hDCTemp3, xType2, xBrushFront)
          xType1\Top - #PeekHeightP
          xType1\Bottom - #PeekHeightP
          Next
;        xType1\Top = #PeekBottommostY
        CompilerElse
        xLong2 = PeekF(*SpecCur) * PeekF(*SpecBoost) * #BoostStops
        xLong3 = PeekB(*SpecMaxPK)
        If xLong2 > xLong3
          xLong2 = xLong3
          EndIf
        xLong4 = PeekB(*SpecLst)
        If xLong2 > xLong4
;Debug "Increase " + Str(xLong4) + " to " + Str(xLong2)
          PokeB(*SpecLst, xLong2)
          xType1\Top = #PeekBottommostY - xLong4 * #PeekHeightP
          xType1\Bottom = xType1\Top + #PeekHeight
          For xLong5 = xLong4 + 1 To xLong2
            ScaleRectToInner(xType1, xType2)
            FillRect_(hDCTemp3, xType2, xBrushFront)
            xType1\Top - #PeekHeightP
            xType1\Bottom - #PeekHeightP
            Next
          ElseIf xLong2 < xLong4
;Debug "Decrease " + Str(xLong4) + " to " + Str(xLong2)
          PokeB(*SpecLst, xLong2)
          xType1\Top = #PeekBottommostY - xLong2 * #PeekHeightP
          xType1\Bottom = xType1\Top + #PeekHeight
          For xLong5 = xLong2 + 1 To xLong4
            ScaleRectToInner(xType1, xType2)
            FillRect_(hDCTemp3, xType2, xBrushBack)
            xType1\Top - #PeekHeightP
            xType1\Bottom - #PeekHeightP
            Next
          EndIf
        CompilerEndIf
  
      xType1\Left + 66
      xType1\Right + 66
      *SpecCur + 4
      CompilerIf Not #ClearOldInfoBmp
        *SpecLst + 1
        CompilerEndIf
      *SpecMaxPK + 1
      *SpecBoost + 4
      Next
    EndIf
  EndProcedure

Procedure ResizedSelfPart()
  ;Debug "MaringLeft: " + Str(SrcMarginLeft) + " MarginTop: " + Str(SrcMarginTop)
  RenderInnerTop = ScalePosY(#PeekAreaTop)
  ;RenderInnerHeight = ScalePosY(#PeekAreaInnerHeight) - RenderInnerTop + #InfoIntHeight
  RenderInnerHeight = RenderHeight - RenderInnerTop - ScalePosY(127)
  EndProcedure
; IDE Options = PureBasic 5.22 LTS (Windows - x64)
; CursorPosition = 7
; Folding = ---
; EnableAsm
; EnableXP
; Executable = ..\_Wallpaper Ex - PSF Logo.exe
; DisableDebugger
; AddResource = Wallpaper Ex - PSF Logo.rc