EnableExplicit

#ClearOldInfoBmp = #True
#LEDMode = $ff00
#CustomPeakInnerSize = #False
;#CustomPeakSizeMul = 7
;#CustomPeakSizeDiv = 8
;#CustomPeakSizePlus = 0
#CustomPeakSizeMul = 1
#CustomPeakSizeDiv = 3
#CustomPeakSizePlus = 32

#ProgressColorCur = $D1B098
#ProgressColorTot = $706040

#OnPicRender = $680000 ; misuse $00xxxx / $000001 for full trans, $ff0000 for full black
#AlphaBackColor = $160500
#MMonitor = 1
#WarnMsg = #False
#WallBmpWidth = 1920
#WallBmpHeight = 1080
#PicSizeYOX = 300
#PicPos = 5
#PartID = 51885 ; stars/encircle
#MaxTick = $1000
#BarPos = 4
#BarOffset = 0
#BlackenTextBack = #True

Global MaxSize.l


#SpecSize = 32
#SpecSizeX = #SpecSize - 1
#SpecSizeXR = #SpecSize * 2 - 1
#ParticleRenderCountMax = #SpecSize * 200 
#ParticleRenderCountMaxX = #ParticleRenderCountMax - 1
;#LargeRects = 0
;#RenderMainInfoMySelf = 2 ; 1 = yes, 2=yes with transparency!!!
;CompilerIf #RenderMainInfoMySelf = 2
  ;Global TransparentCenterMul.f = 0.7
  ;CompilerEndIf
#xStarColMulAlt = #False
;CompilerIf #RenderMainInfoMySelf = 2
  ;Global TransparentCenterMul.f = 0.7
  ;CompilerEndIf
#SepStereo = #False

Global Dim xCurSpec.f(#SpecSizeXR)
Global Dim xStarColMul.l(#SpecSizeX)
CompilerIf #xStarColMulAlt
  CompilerElse
  Global Dim xStarColMulAlt.l(#SpecSizeX)
  CompilerEndIf
Global SSize.l

Procedure InitColors()
  Define.l xLong1
  Define.l xLong2
  #SpecSizeHalf = #SpecSize >> 1
  #SpecSizeHalfX = #SpecSizeHalf - 1

  For xLong1 = 0 To #SpecSizeHalfX
    ;xLong2 = xLong1  * $ff / #SpecSizeHalf
    xLong2 = ((xLong1 * Sqr(Sqr(xLong1)) * $ff / #SpecSizeHalf / Sqr(Sqr(#SpecSizeHalf)) ))
    xStarColMul(xLong1) = $ff0000 + xLong2 * $100 - xLong2 * $10000

    CompilerIf #xStarColMulAlt
      CompilerElse
      ;xLong2 = xLong1 * $28 / #SpecSizeHalf
      xLong2 = xLong2 * $28 / 255
      xStarColMulAlt(xLong1) = $181818 + $280000 + xLong2 * $100 - xLong2 * $10000
      CompilerEndIf

    xLong2 = ((xLong1 / Sqr(Sqr(xLong1)) * $ff / (#SpecSizeHalf / Sqr(Sqr(#SpecSizeHalf))) ))
    xStarColMul(xLong1 + #SpecSizeHalf) = $ff00 + xLong2 - xLong2 * $100
    CompilerIf #xStarColMulAlt
      CompilerElse
      ;xLong2 = xLong1 * $28 / #SpecSizeHalf
      xLong2 = xLong2 * $28 / 255
      xStarColMulAlt(xLong1 + #SpecSizeHalf) = $181818 + $2800 + xLong2 - xLong2 * $100
      CompilerEndIf
    Next
Debug"-"
  EndProcedure

Declare RenderSelfPart(SkipFrame.l, xElapsedTicks.l)

InitColors()

IncludeFile "LSDemo (Wallpaper).pb"




Procedure.l CLng(xDouble1.f)
  Define.l Result = xDouble1
  ProcedureReturn Result
  EndProcedure
  
  
Procedure AddRealLine(PosX2.l, PosY2.l, PosX1.l, PosY1.l, xColor.l)
  Define.l xLong1
  Define.l xLong2
;  Define.l xLong3
CompilerIf #RenderMainInfoMySelf
  Define.f X1
  Define.l X2
  CompilerEndIf
  Define.RECT CurPartRD

  xColor = CreateSolidBrush_(xColor)
  If xColor
    For xLong1 = PosY1 To PosY2
      If PosY1 = PosY2
        xLong2 = PosX1
        Else
        xLong2 = PosX1 + (PosX2 - PosX1) * (xLong1 - PosY1) / (PosY2 - PosY1)
        EndIf
      CurPartRD\Top = xLong1
      CurPartRD\Bottom = xLong1 + 1
      CurPartRD\Left = xLong2
      CurPartRD\Right = xLong2 + SSize
      FillRect_(hDCTemp3, CurPartRD, xColor)
      Next
    DeleteObject_(xColor)
    EndIf
  EndProcedure

  
Procedure AddRealLineO(PosX1.l, PosY1.l, PosX2.l, PosY2.l, xColor.i)
  Define.l xLong1
  Define.l xLong2
  Define.l xLong3
  Define.l S = 1
CompilerIf #RenderMainInfoMySelf
  Define.f X1
  Define.l X2
  CompilerEndIf
  Define.RECT CurPartRD

  ;CurPartRD\Left = X2 - S
  ;CurPartRD\Right = X2 + S
  ;CurPartRD\Top = Y2 - S
  ;CurPartRD\Bottom = Y2 + S
  ;ParticleRenderData(ParticleRenderCount)\Brush = $ffffff
  ;OptimizeAndAddRect()
  ;ProcedureReturn

  xColor = CreateSolidBrush_(xColor)
  If xColor
    If Abs(PosX2 - PosX1) < Abs(PosY2 - PosY1)
      If PosX1 > PosX2
        xLong1 = PosX1
        PosX1 = PosX2
        PosX2 = xLong1
        xLong1 = PosY1
        PosY1 = PosY2
        PosY2 = xLong1
        EndIf
      For xLong1 = PosX1 To PosX2
        xLong2 = PosY1 + (PosY2 - PosY1) * (xLong1 - PosX1) / (PosX2 - PosX1+1)
        xLong3 = PosY1 + (PosY2 - PosY1) * (xLong1 +1 - PosX1) / (PosX2 - PosX1+1)
        If xLong2 > xLong3
          CurPartRD\Top = xLong3 - S
          CurPartRD\Bottom = xLong2 + S
          Else
          CurPartRD\Top = xLong2 - S
          CurPartRD\Bottom = xLong3 + S
          EndIf
        CurPartRD\Left = xLong1 - S
        CurPartRD\Right = xLong1 + S
        FillRect_(hDCTemp3, CurPartRD, xColor)
        Next
      Else
      If PosY1 > PosY2
        xLong1 = PosX1
        PosX1 = PosX2
        PosX2 = xLong1
        xLong1 = PosY1
        PosY1 = PosY2
        PosY2 = xLong1
        EndIf
      For xLong1 = PosY1 To PosY2
        xLong2 = PosX1 + (PosX2 - PosX1) * (xLong1 - PosY1) / (PosY2 - PosY1 + 1)
        xLong3 = PosX1 + (PosX2 - PosX1) * (xLong1 + 1 - PosY1) / (PosY2 - PosY1 + 1)
        If xLong2 > xLong3
          CurPartRD\Left = xLong3 - S
          CurPartRD\Right = xLong2+ S
          Else
          CurPartRD\Left = xLong2 - S
          CurPartRD\Right = xLong3+ S
          EndIf
        CurPartRD\Top = xLong1 - S
        CurPartRD\Bottom = xLong1 + S
       ;ParticleRenderCount = ParticleRenderCount + 1
        FillRect_(hDCTemp3, CurPartRD, xColor)
        Next
      EndIf
    DeleteObject_(xColor)
    EndIf
  EndProcedure
  
Procedure RenderSelfPart(SkipFrame.l, xElapsedTicks.l)
  Define.l xLong1
  Define.l xLeft
  Define.l Y2
  CompilerIf #SepStereo
    CompilerElse
    Define.l Y3
    CompilerEndIf
  Define.l ParticleCenterAY
  Define.l ParticleCenterBY

  ParticleCenterAY = ParticleCenterY * 3 / 6
  ParticleCenterBY = ParticleCenterY * 9 / 6
  
  Define.l SBX = ParticleCenterX >> 2
  If SBX > ParticleCenterY >> 1;2
    SBX = ParticleCenterY >> 1;2
    EndIf
  SBX = SBX << 2
  Define.l SBY = SBX
  Define.f Boost = 0.8 ;.5;00
  Define.f Max = 0.15 ;.5;00
  Define.f xVal1 ;.5;00
  Define.f xVal2 ;.5;00
  Define.l BigStep = 1.85 * SBX / #SpecSize
  
  If SetWaveData(0)
    CompilerIf #SpecSize = 1024
      GetFullSpectrumStereoOpt(@xCurSpec(0))
      CompilerElse
      ;GetFullSpectrumStereoOpt(0)
      GetFullSpectrumStereo(0)
      SpectrumCompactStereo(0, 1024, @xCurSpec(0), #SpecSize)
      CompilerEndIf


    If BigStep < 1
      BigStep = 1
      EndIf
  
    SSize = BigStep * 0.8
    If SSize > BigStep - 2
      SSize = BigStep - 2
      EndIf
    If SSize < 2
      SSize = 2
      EndIf
  
    xLeft = ParticleCenterX - 0.75*SBX ; - ((#SpecSize * BigStep) / 8)
    For xLong1 = 0 To #SpecSizeX
      xVal1 = xCurSpec(xLong1) * Boost
      If xVal1 > Max
        xVal1 = Max
        EndIf
      xCurSpec(xLong1) = xVal1
      xVal2 = xCurSpec(xLong1+#SpecSize) * Boost
      If xVal2 > Max
        xVal2 = Max
        EndIf
      xCurSpec(xLong1+#SpecSize) = xVal2
      CompilerIf #SepStereo
        Y2 = SBY * xVal1
        AddRealLine(xLeft - Y2, ParticleCenterAY + Y2, xLeft + Y2, ParticleCenterAY - Y2, xStarColMul(xLong1))
        CompilerElse
        Y2 = SBY * xVal1
        Y3 = SBY * xVal2
        CompilerIf #xStarColMulAlt
          AddRealLine(xLeft - Y2, ParticleCenterBY + Y2, xLeft + Y3, ParticleCenterBY - Y3, #xStarColMulAlt)
          CompilerElse
          AddRealLine(xLeft - Y2, ParticleCenterBY + Y2, xLeft + Y3, ParticleCenterBY - Y3, xStarColMulAlt(xLong1))
          CompilerEndIf
        CompilerEndIf
      xLeft + BigStep
      Next
  ;Define.l xC1 = ParticleRenderCount
    xLeft = ParticleCenterX - SBX; - ((#SpecSize * BigStep) / 8)
    For xLong1 = 0 To #SpecSizeX
      CompilerIf #SepStereo
        Y2 = SBY * xCurSpec(xLong1+#SpecSize)
        AddRealLine(xLeft - Y2, ParticleCenterBY + Y2, xLeft + Y2, ParticleCenterBY - Y2, xStarColMul(xLong1))
        CompilerElse
        Y2 = SBY * xCurSpec(xLong1)
        Y3 = SBY * xCurSpec(xLong1+#SpecSize)
        AddRealLine(xLeft - Y2, ParticleCenterAY + Y2, xLeft + Y3, ParticleCenterAY - Y3, xStarColMul(xLong1))
        CompilerEndIf
  
      xLeft + BigStep
      Next
  ;Debug(Str(xC1) + " / " + Str(ParticleRenderCount - xC1))
    EndIf
  EndProcedure


; IDE Options = PureBasic 5.22 LTS (Windows - x64)
; CursorPosition = 14
; Folding = ---
; EnableAsm
; AddResource = Wallpaper Ex - 3D Spectrum deluxe.rc