EnableExplicit

#LEDMode = $ff00

#CustomPeakRender = #True
#CustomPeakInnerSize = #False
#CustomPeakSizeMul = 6
#CustomPeakSizeDiv = 8
#CustomPeakSizePlus = 0
#ClearOldInfoBmp = #True
#OnPicRender = $680000 ; misuse $00xxxx / $000001 for full trans, $ff0000 for full black
#AlphaBackColor = $160500
#MMonitor = 1
#WarnMsg = #False
#WallBmpWidth = 1920
#WallBmpHeight = 1080
#PicSizeYOX = 300
#PicPos = 5
#PartID = 51885 ; stars/encircle
#MaxTick = $8000
#BarPos = 4
#BarOffset = 0
Global MaxSize.l



#LargePeaks = 1
#PeaksCountMax = 20 ;1024;256
#PeaksCountMaxX = #PeaksCountMax - 1
#PeaksCountMaxP = #PeaksCountMax + 1
#PeaksCountMaxP2 = #PeaksCountMax + 2
#PeaksCountMaxStereoAS = #PeaksCountMax * 2 - 1

#CodeLinesCountMax = 40 ;1024;256
#CodeLinesCountMaxX = #CodeLinesCountMax - 1
;#CodeLinesCountMaxP = #CodeLinesCountMax + 1
#CodeLinesCountMaxSK = 4
#CodeLinesCountMaxSP = (#CodeLinesCountMax - #CodeLinesCountMaxSK) >> 1
#CodeLinesCountMaxPU = #CodeLinesCountMax + #CodeLinesCountMaxSK
#CodeLinesCountMaxStereoAS = #CodeLinesCountMax * 2 - 1


#ParticleRenderCountMax = #PeaksCountMax * 2
#ParticleRenderCountMaxX = #ParticleRenderCountMax - 1


#LargeRects = 1



;#RenderMainInfoMySelf = 2 ; 1 = yes, 2=yes with transparency!!!
;CompilerIf #RenderMainInfoMySelf = 2
  ;Global TransparentCenterMul.f = 0.66
  ;CompilerEndIf

; 20
Enumeration
  #AP_EAX
  #AP_EBX
  #AP_ECX
  #AP_EDX
  #AP_ESP
  #AP_EBP
  #AP_ESI
  #AP_EDI
  #AP_EIP
  #AP_Reserved1
  #AP_ST0
  #AP_ST1
  #AP_ST2
  #AP_ST3
  #AP_ST4
  #AP_ST5
  #AP_ST6
  #AP_ST7
  EndEnumeration

Global Dim xCodeOf.i(#CodeLinesCountMaxX)
Global Dim xCodeHx.s(#CodeLinesCountMaxX)
Global Dim xCodeSh.s(#CodeLinesCountMaxX)
Global Dim xCodeLn.s(#CodeLinesCountMaxX)
Global Dim xCodeCl.l(#CodeLinesCountMaxX)

Global Dim xCurSpec.f(#PeaksCountMaxStereoAS)
Global Dim xOptSpec.f(#PeaksCountMaxStereoAS)
;Macro xOptSpec(Index)
  ;xCurSpec(Index)
  ;EndMacro
Global Dim xCurBeat.f(1)
;Global Dim PreX.l(#PeaksCountMax)
;Global Dim PreY.l(#PeaksCountMaxX)

Declare RenderSelfPart(SkipFrame.l, xElapsedTicks.l)
Declare ChooseCode()
ChooseCode()

IncludeFile "LSDemo (Wallpaper).pb"

Macro Floor(xTerm)
  Round((xTerm), #PB_Round_Down)
  EndMacro

Procedure RenderSelfPart(SkipFrame.l, xElapsedTicks.l)
  Define.l xLong1
  Define.i MyMaxSize
  Define.i OffX
  Define.i OffY
  Define.RECT xType1
  Define.POINT xType2
  Define.s xChar1
  Define.i hFontOld
  Define.i xLong2

  Define.f Boost = 1.5 ; 1.5;00
  If SetWaveData(0)
    GetFullSpectrumStereoOpt(0)
    SpectrumCompactStereo(0, 1024, @xCurSpec(0), #PeaksCountMax)
    SpectrumCompactStereo(@xCurSpec(0), #PeaksCountMax, @xCurBeat(0), 1)
    For xLong1 = 0 To #PeaksCountMaxX
      xOptSpec(xLong1) = 0.25 + 0.75 * xCurSpec(xLong1) ;+ 0.15 * xCurBeat(0)
      xOptSpec(xLong1 + #PeaksCountMax) = 0.25 + 0.75 * xCurSpec(xLong1 + #PeaksCountMax) ;+ 0.15 * xCurBeat(1)
      Next
    EndIf

;*hBitmapTxt

  ;PreX(#PeaksCountMax) = PreX(0)
  MyMaxSize = MaxSize / 3
  ;hFontOld = SelectObject_(hDCTemp3, hFontLarge)
  hFontOld = SelectObject_(hDCTemp3, hFontTitle)
  If hFontOld
    SetTextColor_(hDCTemp3, $ffffff)
    SetBkMode_(hDCTemp3, #TRANSPARENT)
    For xLong1 = 0 To #CodeLinesCountMaxX
      xChar1 = Right("00000000" + Hex(xCodeOf(xLong1)), 8)
      xLong2 = Len(xCodeHx(xLong1))
      If xLong2
        TextOut_(hDCTemp3, 20, 10 + (xLong1 * (RenderInnerHeight - 20)) / #CodeLinesCountMax, @xChar1, Len(xChar1))
        TextOut_(hDCTemp3, 110 + 25, 10 + (xLong1 * (RenderInnerHeight - 20)) / #CodeLinesCountMax, @xCodeHx(xLong1), xLong2)
        EndIf
      TextOut_(hDCTemp3, 280, 10 + (xLong1 * (RenderInnerHeight - 20)) / #CodeLinesCountMax, @xCodeSh(xLong1), Len(xCodeSh(xLong1)))
      TextOut_(hDCTemp3, 525 + 25, 10 + (xLong1 * (RenderInnerHeight - 20)) / #CodeLinesCountMax, @xCodeLn(xLong1), Len(xCodeLn(xLong1)))


      xChar1 = StrF(xCurSpec(xLong1) * 100, 2) + "% / "
      GetTextExtentPoint32_(hDCTemp3, @xChar1, Len(xChar1), @xType2)
      TextOut_(hDCTemp3, RenderWidth - 20 - 80 - xType2\x, 10 + (xLong1 * (RenderInnerHeight - 20)) / #CodeLinesCountMaxPU, @xChar1, Len(xChar1))

      ;xChar1 = StrF(xCurSpec(#CodeLinesCountMax + xLong1) * 100, 2) + "%"
      ;GetTextExtentPoint32_(hDCTemp3, @xChar1, Len(xChar1), @xType2)
      ;If xLong1 < #CodeLinesCountMaxP / 2
        ;TextOut_(hDCTemp3, RenderWidth - 20 - xType2\x, 10 + (xLong1 * (RenderInnerHeight - 20)) / #CodeLinesCountMaxP2, @xChar1, Len(xChar1))
        ;Else
        ;TextOut_(hDCTemp3, RenderWidth - 20 - xType2\x, 10 + ((xLong1 + 2) * (RenderInnerHeight - 20)) / #CodeLinesCountMaxP2, @xChar1, Len(xChar1))
        ;EndIf
      Next
    SelectObject_(hDCTemp3, hFontOld)
    EndIf
  EndProcedure

Procedure.i CallCode(LineNR, *CodeBase, *CodeOff, xParam.i)
  xCodeCl(LineNR) = $ffffff
  xCodeSh(LineNR) = "CALL DWORD 0x" + Right("00000000" + Hex(xParam), 8)
  ;xCodeLn(LineNR) = xCodeLn(LineNR) + "=" + Str(xParam)
  xParam - ((*CodeOff + 5) - *CodeBase)
  ;xParam = -xParam
  EnableASM
  MOV eax, xParam
  BSWAP eax
  MOV xParam, eax
  DisableASM
  xCodeHx(LineNR) = "E8 " + Right("00000000" + Hex(xParam), 8)
  ProcedureReturn 5
  EndProcedure

Procedure JumpShCode(LineNR, *CodeBase, *CodeOff, xParam.i)
  Define.s xChar1
  Define.s xChar2
  xCodeCl(LineNR) = $ffffff
  Select xParam & $ff00
    Case $7400
      xChar1 = "JZ"
    Case $7500
      xChar1 = "JNZ"
    Case $EB00
      xChar1 = "JMP"
    EndSelect
  xCodeSh(LineNR) = xChar1 + " SHORT 0x" + Right("00000000" + Hex(*CodeOff + (xParam & $ff) + 2), 8)
  ;EnableASM
    ;MOV eax, xParam
    ;BSWAP eax
    ;SHR eax, 16
    ;MOV xParam, eax
    ;DisableASM
  xCodeHx(LineNR) = Right("0000" + Hex(xParam & $ffff), 4)
  ProcedureReturn 2
  EndProcedure

Procedure PushCode(LineNR, *CodeBase, *CodeOff, xParam.i)
  xCodeCl(LineNR) = $ffffff
  xCodeSh(LineNR) = "PUSH DWORD 0x" + Right("00000000" + Hex(xParam), 8)
  If (xParam & $ffffff80) = 0
    xCodeLn(LineNR) = xCodeLn(LineNR) + "=" + StrU(xParam)
    xCodeHx(LineNR) = "6A " + Right("00" + Hex(xParam), 2)
    ProcedureReturn 2
    ElseIf (xParam & $ffffff80) = $ffffff80
    xCodeLn(LineNR) = xCodeLn(LineNR) + "= -" + StrU(-xParam)
    xCodeHx(LineNR) = "6A " + Right("00" + Hex(xParam), 2)
    ProcedureReturn 2
    Else
    If xParam & $80000000
      xCodeLn(LineNR) = xCodeLn(LineNR) + "=-" + StrU(-xParam)
      Else
      xCodeLn(LineNR) = xCodeLn(LineNR) + "=" + StrU(xParam)
      EndIf
    EnableASM
    MOV eax, xParam
    BSWAP eax
    MOV xParam, eax
    DisableASM
    xCodeHx(LineNR) = "68 " + Right("00000000" + Hex(xParam), 8)
    ProcedureReturn 5
    EndIf
  EndProcedure

Procedure PushCurSpec0(LineNR, *CodeBase, *CodeOff, xParam.i)
  ProcedureReturn PushCode(LineNR, *CodeBase, *CodeOff, @xCurSpec(0))
  EndProcedure

Procedure MovEAXMemPtr(LineNR, *CodeBase, *CodeOff, xParam.i)
  xCodeCl(LineNR) = $ffffff
  xCodeSh(LineNR) = "MOV EAX, DWORD [0x" + Right("00000000" + Hex(xParam), 8) + "]"
  xCodeLn(LineNR) = ""
  EnableASM
  MOV eax, xParam
  BSWAP eax
  MOV xParam, eax
  DisableASM
  xCodeHx(LineNR) = "A1 " + Right("00000000" + Hex(xParam), 8)
  ProcedureReturn 5
  EndProcedure

Procedure MovEAXBmpC(LineNR, *CodeBase, *CodeOff, xParam.i)
  ProcedureReturn MovEAXMemPtr(LineNR, *CodeBase, *CodeOff, @*hBitmapTxt)
  EndProcedure

Procedure MovEAXBmpG(LineNR, *CodeBase, *CodeOff, xParam.i)
  ProcedureReturn MovEAXMemPtr(LineNR, *CodeBase, *CodeOff, @*hBitmapGen)
  EndProcedure





Macro AddCodeEx(CodeSizeOrPtr, HexCode, xColor, Text1, Text2)
  Data.i CodeSizeOrPtr
  Data.s HexCode
  Data.l xColor
  Data.s Text1
  Data.s Text2
  EndMacro

Macro cMovEBXESPPtr(OffsetStr)
  AddCodeEx(4, "8B5C24 " + OffsetStr, $00ffff, "MOV EBX, DWORD [ESP+0x" + OffsetStr + "]", "")
  EndMacro

Macro cPushESPPtr(OffsetStr)
  AddCodeEx(4, "FF7424 " + OffsetStr, $00ffff, "PUSH DWORD [ESP+0x" + OffsetStr + "]", "")
  EndMacro

Macro cProc(Text1)
  AddCodeEx(0, "", $00ffff, "Proc " + Text1, "")
  EndMacro

Macro cPushEAX()
  AddCodeEx(1, "50", $00ffff, "PUSH EAX", "")
  EndMacro

Macro cPushEBX()
  AddCodeEx(1, "53", $00ffff, "PUSH EBX", "")
  EndMacro

Macro cPopEBX()
  AddCodeEx(1, "5B", $00ffff, "POP EBX", "")
  EndMacro

;Macro cNOP()
  ;AddCodeEx(1, "90", $ffffff, "NOP", "")
  ;EndMacro

Macro cCall(xProcAddr, xProcName)
  Data.i @CallCode()
  Data.i xProcAddr
  Data.s xProcName
  EndMacro

Macro cJZ(Offset)
  Data.i @JumpShCode()
  Data.i $7400 + ((Offset) & $ffffff)
  Data.s ""
  EndMacro

Macro cJNZ(Offset)
  Data.i @JumpShCode()
  Data.i $7500 + ((Offset) & $ffffff)
  Data.s ""
  EndMacro

Macro cPushDW(xParam, ParamName)
  Data.i @PushCode()
  Data.i xParam
  Data.s ParamName
  EndMacro

Macro cPushCurSpec0(ParamName)
  Data.i @PushCurSpec0()
  Data.i 0
  Data.s ParamName
  EndMacro

Macro cMovEAXBmpC(ParamName)
  Data.i @MovEAXBmpC()
  Data.i 0
  Data.s ParamName
  EndMacro

Macro cMovEAXBmpG(ParamName)
  Data.i @MovEAXBmpG()
  Data.i 0
  Data.s ParamName
  EndMacro

Macro cEndP0()
  AddCodeEx(1, "C3", $ffffff, "RET", "")
  Data.i -1
  EndMacro

Macro cEndP(BytesStr)
  ;AddCodeEx(1, "C2 00" + BytesStr, $ffffff, "RET 0x00" + BytesStr, "")
  AddCodeEx(3, "C2 00" + BytesStr, $ffffff, "RET 0x" + BytesStr, "")
  Data.i -1
  EndMacro

Macro cOrEAXEAX()
  AddCodeEx(2, "09C0", $ffffff, "Or EAX, EAX", "")
  EndMacro

Procedure GenerateCode(*RealPtr, *Template, *SelLine)
  ;xCode
  Define *Pointer = *Template
  Define *CodeOff = *RealPtr
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3

  For xLong1 = 0 To #CodeLinesCountMaxX
    If xLong1 = #CodeLinesCountMaxSP
      xLong1 + #CodeLinesCountMaxSK
      EndIf
    xCodeOf(xLong1) = *CodeOff
    xLong2 = PeekI(*Pointer)
    If xLong2 = -1
      xCodeHx(xLong1) = "90"
      xCodeSh(xLong1) = "NOP"
      xCodeLn(xLong1) = ""
      xCodeCl(xLong1) = $ffffff
      *CodeOff + 1
      ElseIf (xLong2 > $100)
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
        xCodeLn(xLong1) = PeekS(*Pointer + 16)
        xLong3 = Len(xCodeLn(xLong1))
        *CodeOff + CallFunctionFast(xLong2, xLong1, *RealPtr, *CodeOff, PeekI(*Pointer + 8))
        *Pointer + 18 + xLong3
        CompilerElse
        xCodeLn(xLong1) = PeekS(*Pointer + 8)
        xLong3 = Len(xCodeLn(xLong1))
        *CodeOff + CallFunctionFast(xLong2, xLong1, *RealPtr, *CodeOff, PeekI(*Pointer + 4))
        *Pointer + 9 + xLong3
        CompilerEndIf
      ;*CodeOff + xLong2
      Else

      ;CodeSizeOrPtr.i
      ;HexCode.s
      ;xColor.l
      ;Text1.s
      ;Text2.s
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
        xCodeHx(xLong1) = PeekS(*Pointer + 8)
        *Pointer + 10 + Len(xCodeHx(xLong1)) << 1
        xCodeCl(xLong1) = PeekL(*Pointer)
        xCodeSh(xLong1) = PeekS(*Pointer + 4)
        *Pointer + 6 + Len(xCodesh(xLong1)) << 1
        xCodeLn(xLong1) = PeekS(*Pointer)
        *Pointer + 2 + Len(xCodeLn(xLong1)) << 1
        CompilerElse
        xCodeHx(xLong1) = PeekS(*Pointer + 4)
        *Pointer + 5 + Len(xCodeHx(xLong1))
        xCodeCl(xLong1) = PeekL(*Pointer)
        xCodeSh(xLong1) = PeekS(*Pointer + 4)
        *Pointer + 5 + Len(xCodesh(xLong1))
        xCodeLn(xLong1) = PeekS(*Pointer)
        *Pointer + 1 + Len(xCodeLn(xLong1))
        CompilerEndIf
      *CodeOff + xLong2
      EndIf
    Next
  EndProcedure

Procedure ChooseCode()
  GenerateCode(?cpMainLoop, ?cpMainLoop, ?cpMainLoop)
  EndProcedure

DataSection
cpMainLoop:
  cProc("RenderCallback")
  cPushEBX()
  cMovEBXESPPtr("08")
  cPushDW(0, "*WaveData")
  cCall(@SetWaveData(), "SetWaveData")
  cOrEAXEAX()
  cJZ(2+5 + 2+5+5+2+5)
  cPushDW(0, "*WaveData")
  cCall(@GetFullSpectrumStereoOpt(), "GetFullSpectrumStereoOpt")

  cPushDW(3, "ArraySizeOut")
  ;cPushEx(@xCurSpec(0), "*SpectrumOut")
  cPushCurSpec0("*SpectrumOut")
  cPushDW(1024, "ArraySizeIn")
  cPushDW(0 ,"*SpectrumIn")
  cCall(@SpectrumCompactStereo(), "SpectrumCompactStereo")
  cPushEBX()
  cCall(@RenderSelf(), "PrepareDrawing")
  cPushEBX()
  cCall(@RenderSelfPart(), "DrawNow")
  cMovEAXBmpC("")
  cOrEAXEAX()
  cJNZ(5)
  cMovEAXBmpG("")
  cPushEAX()
  cPushEBX()
  cCall(@CalcAndDrawInfoPos(), "CalcAndDrawInfoPos")
  cPopEBX()
  cEndP("04")
  EndDataSection


; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 339
; FirstLine = 331
; Folding = ------
; EnableAsm
; Executable = Simple spectrum x4.lpanim.dll
; CompileSourceDirectory
; IncludeVersionInfo
; AddResource = Wallpaper Ex - 3D Pie.rc