EnableExplicit

Global.i hImgG1

IncludeFile "..\..\source\LineSpec.pb"

Procedure DoRender()
  Define.i xTime
  Define.i hMem = RecGetPtr(@xTime)
  If hMem
    Dim xSingleA1.f(1024*2-1)
    Dim xSingleA2.f(128*2-1)
    Define.RECT xType1
    Define.RECT xType2
    Define.i xCtl
    Define.i hBmp
    Define.s xChar1
    
    SetWaveData(0)
    GetFullSpectrumStereoOpt(@xSingleA1(0))
    ;GetFullSpectrumStereo(@xSingleA1(0))
    ;SpectrumOptimizeStereo(@xSingleA1(0), 1024, @xSingleA1(0))
    ;GetFullSpectrumMono(@xSingleA1(0))
    ;GetFullSpectrumMonoOpt(@xSingleA1(0))
    ;SpectrumOptimizeMono(@xSingleA1(0), 1024, @xSingleA1(0))
    
    ;SpectrumOptimizeStereo(@xSingleA1(0), 1024, @xSingleA1(0))
    ;SpectrumOptimizeMono(@xSingleA1(0), 1024, @xSingleA1(0))
    SpectrumCompactMono(@xSingleA1(0),1024, @xSingleA2(0), 128)
    SpectrumExpandMono(@xSingleA2(0), 128, @xSingleA1(0), 1024)
    ;SpectrumMonoMixJv066(@xSingleA1(0), 1024, @xSingleA1(0))
    ;FTTOptimizeLSF1(@xSingleA1(0), 1024, 0, @xSingleA1(0))
    xChar1 = Hex(xTime)
    xTime = Len(xChar1)
    Define.i hDC = GetDC_(0)
    If hDC
      hBmp = CreateCompatibleBitmap_(hDC, 1024,240)
      hDC = ReleaseDC_(0, hDC)
      If hBmp
        hDC = CreateCompatibleDC_(0)
        If hDC
          Define.i hBmpOld = SelectObject_(hDC, hBmp)
          If hBmpOld
            xType2\bottom = 240
            xType2\right = 1024
            FillRect_(hdc, @xType2, #COLOR_WINDOW + 1)
            xType1\bottom = 120
            xType1\right = 1
            xType2\top = 120
            xType2\right = 1
            Define.i xLong1
            ;Define.i hBrush1 = CreateSolidBrush_($ff)
            For xLong1 = 0 To 1023
              xType1\top = 119.4 - xSingleA1(xLong1) * 120
              FillRect_(hDC, @xType1, #COLOR_HIGHLIGHT + 1)
              xType1\left + 1
              xType1\right + 1
              xType2\bottom = 119.6 + xSingleA1(xLong1 + 1024) * 120
              FillRect_(hDC, @xType2, #COLOR_HIGHLIGHT + 1)
              xType2\left + 1
              xType2\right + 1
              Next
            SetBkMode_(hDC, #TRANSPARENT)
            SetTextColor_(hDC, #COLOR_WINDOWTEXT)
            TextOut_(hdc, 3, 1, @xChar1, xTime)
            SelectObject_(hDC, hBmpOld)
            EndIf
          hBmpOld = GetGadgetState(hImgG1)
          SetGadgetState(hImgG1, hBmp)
          DeleteObject_(hBmpOld)
          DeleteDC_(hdc)
          Else
          DeleteObject_(hBmp)
          EndIf
        EndIf
      EndIf
    EndIf
  EndProcedure

#PBWStyle = #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_TitleBar | #PB_Window_ScreenCentered
Define.i hWin = OpenWindow(#PB_Any, 0, 0, 1024, 240, "LineSpec Test Window", #PBWStyle)
If hWin
  hImgG1 = ImageGadget(#PB_Any, 0, 0, 1024, 240, 0)
  If hImgG1
    init(0)
    If recstart(0)
      Define.i xLong1
      Define.l xBool1
      Repeat
        If WindowEvent() = #PB_Event_CloseWindow
          Break
          EndIf
        DoRender()
        ForEver
      recstop()
      EndIf
    EndIf
  EndIf

; IDE Options = PureBasic 4.61 (Windows - x86)
; CursorPosition = 8
; FirstLine = 2
; Folding = -
; EnableAsm
; Executable = Test64.exe
; DisableDebugger